// DlgCardReaderCfg.cpp : implementation file
//

#include "stdafx.h"
#include "clientdemo.h"
#include "DlgCardReaderCfg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgCardReaderCfg dialog


CDlgCardReaderCfg::CDlgCardReaderCfg(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgCardReaderCfg::IDD, pParent)
    ,m_iUserID(0)
    ,m_iDeviceID(0)
{
	//{{AFX_DATA_INIT(CDlgCardReaderCfg)
	m_BEnable = FALSE;
	m_BEnableFailAlarm = FALSE;
	m_dwCardReaderNo = 1;
	m_dwSwipeInterval = 0;
	m_dwPressTimeOut = 0;
	m_dwMaxReadCardFailNum = 0;
	m_BEnableTamperCheck = FALSE;
	m_dwOfflineCheckTime = 0;
	//}}AFX_DATA_INIT
}


void CDlgCardReaderCfg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgCardReaderCfg)
	DDX_Control(pDX, IDC_COMB_AC_CREADER_TYPE, m_cmbType);
	DDX_Control(pDX, IDC_COMB_AC_CREADER_BUZZERPOLARITY, m_cmbBuzzerPolarity);
	DDX_Control(pDX, IDC_COMB_AC_CREADER_ERRORLED, m_cmbErrorLed);
	DDX_Control(pDX, IDC_COMB_AC_CREADER_OKLED, m_cmbOKLed);
	DDX_Check(pDX, IDC_CHK_AC_READER_ENABLE, m_BEnable);
	DDX_Check(pDX, IDC_CHK_AC_READER_ENABLEFAILALARM, m_BEnableFailAlarm);
	DDX_Text(pDX, IDC_EDT_AC_CARDERCFG_NO, m_dwCardReaderNo);
	DDX_Text(pDX, IDC_EDT_AC_CARDERCFG_SWIPEINTERVAL, m_dwSwipeInterval);
	DDX_Text(pDX, IDC_EDT_AC_CARDERCFG_PRESSTIMEOUT, m_dwPressTimeOut);
	DDX_Text(pDX, IDC_EDT_AC_CARDERCFG_MAXREADCARDFAILNUM, m_dwMaxReadCardFailNum);
	DDX_Check(pDX, IDC_CHK_AC_READER_ENABLETAMPERCHECK, m_BEnableTamperCheck);
	DDX_Text(pDX, IDC_EDT_AC_OFFLINE_CHECKTIME, m_dwOfflineCheckTime);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgCardReaderCfg, CDialog)
	//{{AFX_MSG_MAP(CDlgCardReaderCfg)
	ON_BN_CLICKED(IDC_BUT_AC_CARDREADERCFG_GET, OnButGet)
	ON_BN_CLICKED(IDC_BUT_AC_CARDREADERCFG_SET, OnButSet)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgCardReaderCfg message handlers

void CDlgCardReaderCfg::OnButGet() 
{
	// TODO: Add your control notification handler code here
    UpdateData(TRUE); 
    NET_DVR_CARD_READER_CFG struReaderCfg = {0}; 
    DWORD dwRet; 
    if ( !NET_DVR_GetDVRConfig(m_iUserID, NET_DVR_GET_CARD_READER_CFG, m_dwCardReaderNo, &struReaderCfg, sizeof(struReaderCfg),  &dwRet))
    {
        g_pMainDlg->AddLog(m_iDeviceID, OPERATION_FAIL_T, "NET_DVR_GET_CARD_READER_CFG");
        MessageBox("NET_DVR_GET_CARD_READER_CFG Fail"); 
        return ; 
    }
    g_pMainDlg->AddLog(m_iDeviceID, OPERATION_SUCC_T, "NET_DVR_GET_CARD_READER_CFG");
    m_BEnable = struReaderCfg.byEnable; 
    m_BEnableFailAlarm = struReaderCfg.byEnableFailAlarm; 
    m_cmbType.SetCurSel(struReaderCfg.byCardReaderType-1);
    m_cmbOKLed.SetCurSel(struReaderCfg.byOkLedPolarity); 
    m_cmbErrorLed.SetCurSel(struReaderCfg.byErrorLedPolarity); 
    m_cmbBuzzerPolarity.SetCurSel(struReaderCfg.byBuzzerPolarity); 
    m_dwSwipeInterval = struReaderCfg.bySwipeInterval; 
    m_dwPressTimeOut = struReaderCfg.byPressTimeout; 
    m_dwMaxReadCardFailNum = struReaderCfg.byMaxReadCardFailNum; 
    m_BEnableTamperCheck = struReaderCfg.byEnableTamperCheck; 
    m_dwOfflineCheckTime = struReaderCfg.byOfflineCheckTime; 
	UpdateData(FALSE); 
}

void CDlgCardReaderCfg::OnButSet() 
{
	// TODO: Add your control notification handler code here
    UpdateData(TRUE); 
    NET_DVR_CARD_READER_CFG struReaderCfg = {0}; 
    struReaderCfg.dwSize = sizeof(struReaderCfg);
    struReaderCfg.byEnable = m_BEnable;
    struReaderCfg.byEnableFailAlarm = m_BEnableFailAlarm;
    struReaderCfg.byCardReaderType = m_cmbType.GetCurSel()+1;
    struReaderCfg.byOkLedPolarity = m_cmbOKLed.GetCurSel(); 
    struReaderCfg.byErrorLedPolarity = m_cmbErrorLed.GetCurSel(); 
    struReaderCfg.byBuzzerPolarity = m_cmbBuzzerPolarity.GetCurSel(); 
    struReaderCfg.bySwipeInterval = (BYTE) m_dwSwipeInterval; 
    struReaderCfg.byPressTimeout = (BYTE) m_dwPressTimeOut;
    struReaderCfg.byMaxReadCardFailNum = (BYTE)m_dwMaxReadCardFailNum;
    struReaderCfg.byEnableTamperCheck = m_BEnableTamperCheck; 
    struReaderCfg.byOfflineCheckTime = (BYTE)m_dwOfflineCheckTime; 
    if (!NET_DVR_SetDVRConfig(m_iUserID, NET_DVR_SET_CARD_READER_CFG, m_dwCardReaderNo, &struReaderCfg, sizeof(struReaderCfg)))
    {
        g_pMainDlg->AddLog(m_iDeviceID, OPERATION_FAIL_T, "NET_DVR_SET_CARD_READER_CFG");
        MessageBox("NET_DVR_SET_CARD_READER_CFG Fail");
        return ; 
	}
    g_pMainDlg->AddLog(m_iDeviceID, OPERATION_SUCC_T, "NET_DVR_SET_CARD_READER_CFG");
}

BOOL CDlgCardReaderCfg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	 m_iDeviceID = g_pMainDlg->GetCurDeviceIndex(); 
     m_iUserID = g_struDeviceInfo[m_iDeviceID].lLoginID; 
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
