// DlgProductAcs.cpp : implementation file
//

#include "stdafx.h"
#include "clientdemo.h"
#include "DlgProductAcs.h"
#include "DlgAcsWorkStatus.h"
#include "DlgDoorConfig.h"
#include "DlgWeekPlan.h"
#include "DlgGroupCfg.h"
#include "DlgMultiCardCfg.h"
#include "DlgClearAcsParam.h"
#include "DlgSneakAndLock.h"
#include "DlgGatewayCardCfg.h"
#include "DlgAlarmNetUser.h"
#include "DlgAlarmHost.h"
#include "DlgAcsCaseSensor.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgProductAcs dialog


CDlgProductAcs::CDlgProductAcs(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgProductAcs::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgProductAcs)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	m_lUserID = -1;
    m_iDeviceIndex = -1;
	m_lChannel = -1;
}


void CDlgProductAcs::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgProductAcs)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgProductAcs, CDialog)
	//{{AFX_MSG_MAP(CDlgProductAcs)
	ON_BN_CLICKED(IDC_BTN_ACS_WORK_STATUS, OnBtnAcsWorkStatus)
	ON_BN_CLICKED(IDC_BUT_AC_PLANCONFIGURE, OnButPlanConfig)
	ON_BN_CLICKED(IDC_BUT_AC_DOORCONFIG, OnButDoorConfig)
	ON_BN_CLICKED(IDC_BTN_ACS_GROUP_CFG, OnBtnAcsGroupCfg)
	ON_BN_CLICKED(IDC_BTN_ACS_MULTI_CARD, OnBtnAcsMultiCard)
	ON_BN_CLICKED(IDC_BTN_ACS_CLEAR, OnBtnAcsClear)
	ON_BN_CLICKED(IDC_BTN_SNEAK_AND_LOCK, OnBtnSneakAndLock)
	ON_BN_CLICKED(IDC_BUT_AC_ALARMINANDOUT, OnButAlarminAndout)
	ON_BN_CLICKED(IDC_BUT_AC_ALARMUSER, OnButAcAlarmUser)
	ON_BN_CLICKED(IDC_BTN_CARD_CFG, OnBtnCardCfg)
	ON_BN_CLICKED(IDC_BTN_CASE_SENSOR, OnBtnCaseSensor)
	ON_BN_CLICKED(IDC_BUT_AC_REMOTECONTROL, OnButAcRemotecontrol)
	ON_BN_CLICKED(IDC_BUT_AC_RS485, OnButAcRs485)
	ON_BN_CLICKED(IDC_BUT_AC_CARDREADERCFG, OnButAcCardreadercfg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgProductAcs message handlers

void CDlgProductAcs::CurCfgUpadate()
{
    int iDeviceIndex = g_pMainDlg->GetCurDeviceIndex();
    if (iDeviceIndex < 0)
    {
        EnableWindow(FALSE);
        return;
    }
   
    EnableWindow(TRUE);
    
	int iChanIndex = g_pMainDlg->GetCurChanIndex();
    if (iChanIndex < 0)
    {
        iChanIndex = 0;//default to config channel one
    }

    m_iDeviceIndex = iDeviceIndex;
    m_lUserID = g_struDeviceInfo[iDeviceIndex].lLoginID;
	m_lChannel= iChanIndex+g_struDeviceInfo[iDeviceIndex].iStartChan;
}

void CDlgProductAcs::OnBtnAcsWorkStatus() 
{
	// TODO: Add your control notification handler code here
    CDlgAcsWorkStatus dlg;
    dlg.m_lUserID = m_lUserID;
    dlg.m_iDeviceIndex = m_iDeviceIndex;
    dlg.DoModal();	
}

void CDlgProductAcs::OnButPlanConfig() 
{
	// TODO: Add your control notification handler code here
	CDlgWeekPlan dlg; 
    dlg.DoModal(); 
}

void CDlgProductAcs::OnButDoorConfig() 
{
	// TODO: Add your control notification handler code here
	CDlgDoorConfig dlg; 
    dlg.DoModal(); 
}

void CDlgProductAcs::OnBtnAcsGroupCfg() 
{
	// TODO: Add your control notification handler code here
	CDlgGroupCfg dlg;
    dlg.m_lUserID = m_lUserID;
    dlg.m_iDevIndex = m_iDeviceIndex;
	dlg.m_lChannel = m_lChannel;
	dlg.DoModal(); 
}

void CDlgProductAcs::OnBtnAcsMultiCard() 
{
	// TODO: Add your control notification handler code here
	CDlgMultiCardCfg dlg;
    dlg.m_lUserID = m_lUserID;
    dlg.m_iDevIndex = m_iDeviceIndex;
	dlg.m_lChannel = m_lChannel;
	dlg.DoModal(); 
}

void CDlgProductAcs::OnBtnAcsClear() 
{
	// TODO: Add your control notification handler code here
	CDlgClearAcsParam dlg;
    dlg.m_lUserID = m_lUserID;
    dlg.m_iDevIndex = m_iDeviceIndex;
	dlg.m_lChannel = m_lChannel;
	dlg.DoModal(); 
}

void CDlgProductAcs::OnBtnSneakAndLock() 
{
	// TODO: Add your control notification handler code here
	CDlgSneakAndLock dlg;
    dlg.m_lUserID = m_lUserID;
    dlg.m_iDevIndex = m_iDeviceIndex;
	dlg.m_lChannel = m_lChannel;
	dlg.DoModal(); 
}

#include "DlgACAlarmInOutCfg.h"
void CDlgProductAcs::OnButAlarminAndout() 
{
	// TODO: Add your control notification handler code here
// 	CDlgAlarmHost dlg; 
//     dlg.m_lServerID = m_lUserID;
//     dlg.m_iDevIndex = m_iDeviceIndex;
//     dlg.m_lChannel = m_lChannel;
// 	dlg.DoModal(); 
    CDlgACAlarmInOutCfg dlg; 
    dlg.DoModal(); 
}

void CDlgProductAcs::OnButAcAlarmUser() 
{
	// TODO: Add your control notification handler code here
	CDlgAlarmNetUser dlg; 
    dlg.m_lServerID = m_lUserID;
    dlg.m_iDevIndex = m_iDeviceIndex;
    dlg.m_dwNetUserNum = 1;
    dlg.DoModal();
}

BOOL CDlgProductAcs::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	//GetAlarmHostAbility(m_struAlarmHostAbility); 
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgProductAcs::OnBtnCardCfg() 
{
	// TODO: Add your control notification handler code here
    CDlgGatewayCardCfg dlg;
    dlg.m_lServerID = m_lUserID;
    dlg.m_iDevIndex = m_iDeviceIndex;
	dlg.DoModal();
}

void CDlgProductAcs::OnBtnCaseSensor() 
{
	// TODO: Add your control notification handler code here
	CDlgAcsCaseSensor dlg;
    dlg.m_lUserID = m_lUserID;
    dlg.m_iDeviceIndex = m_iDeviceIndex;
    dlg.DoModal();
}

#include "DlgGatewayCfg.h"
void CDlgProductAcs::OnButAcRemotecontrol() 
{
	// TODO: Add your control notification handler code here
    CDlgGatewayCfg dlg;
    dlg.m_lServerID = m_lUserID;
    dlg.m_dwGatawayNum = 8;
    dlg.DoModal();
}

#include "DlgAlarmHostRs485.h"
void CDlgProductAcs::OnButAcRs485() 
{
	// TODO: Add your control notification handler code here
    CDlgAlarmHostRs485 dlg;
    dlg.m_lServerID = m_lUserID;
    dlg.m_iDevIndex = m_iDeviceIndex;
    memset(&dlg.m_struDevAbility, 0, sizeof(dlg.m_struDevAbility)); 
//    memcpy(&dlg.m_struDevAbility, &m_struAlarmHostAbility, sizeof(m_struAlarmHostAbility));
    dlg.m_i485SlotNum = 1; 
    dlg.m_iRS485Num = 4;
    dlg.DoModal();
}

#include "DlgCardReaderCfg.h"
void CDlgProductAcs::OnButAcCardreadercfg() 
{
	// TODO: Add your control notification handler code here
	CDlgCardReaderCfg dlg; 
    dlg.DoModal(); 
}
