// DlgRecordHost.cpp : implementation file
//

#include "stdafx.h"
#include "clientdemo.h"
#include "DlgRecordHost.h"
#include "DlgRecordHostCfg.h"
#include "DlgSDIAutoTrackCfg.h"
#include "DlgRecordPublishCfg.h"
#include "DlgRecordControl.h"
#include "DlgRecordHostEndTime.h"
#include "DlgOneKeyPublish.h"
#include "DlgCourseInfo.h"
#include "DlgCourseCfg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// DlgRecordHost dialog


DlgRecordHost::DlgRecordHost(CWnd* pParent /*=NULL*/)
	: CDialog(DlgRecordHost::IDD, pParent)
{
	//{{AFX_DATA_INIT(DlgRecordHost)
	m_nMirrorNum = 0;
	m_nStartChannel = 0;
	//}}AFX_DATA_INIT
	m_iDeviceIndex = 0;
	m_lServerID = 0;
}


void DlgRecordHost::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(DlgRecordHost)
	DDX_Text(pDX, IDC_MIRROR_NUM, m_nMirrorNum);
	DDX_Text(pDX, IDC_START_CHANNEL, m_nStartChannel);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(DlgRecordHost, CDialog)
	//{{AFX_MSG_MAP(DlgRecordHost)
	ON_BN_CLICKED(IDC_BTN_RECORD_HOST_CFG, OnBtnRecordHostCfg)
	ON_BN_CLICKED(IDC_BTN_SDI_AUTO_TRACK, OnBtnSdiAutoTrack)
	ON_BN_CLICKED(IDC_BTN_PUBLISH_CFG, OnBtnPublishCfg)
	ON_BN_CLICKED(IDC_BTN_RECORD_CONTROL, OnBtnRecordControl)
	ON_BN_CLICKED(IDC_BTN_GET_END_TIME, OnBtnGetEndTime)
	ON_BN_CLICKED(IDC_BTN_PUBLISH, OnBtnPublish)
	ON_BN_CLICKED(IDC_BTN_COURSE_CFG, OnBtnCourseCfg)
	ON_BN_CLICKED(IDC_BTN_CURRICULUM_CFG, OnBtnCurriculumCfg)
	ON_BN_CLICKED(IDC_BTN_PPT_DETECT, OnBtnPptDetect)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// DlgRecordHost message handlers

BOOL DlgRecordHost::OnInitDialog()
{
	CDialog::OnInitDialog();
	m_iDeviceIndex = g_pMainDlg->GetCurDeviceIndex();
	m_lServerID =g_struDeviceInfo[m_iDeviceIndex].lLoginID;
	m_nMirrorNum = m_iMirrorNum;
	m_nStartChannel = m_iStartChannel;
	UpdateData(FALSE);
	return TRUE;
}

void DlgRecordHost::OnBtnRecordHostCfg() 
{
	// TODO: Add your control notification handler code here
	DlgRecordHostCfg dlg;
	dlg.m_lUserID = m_lServerID;
	dlg.m_iDeviceIndex = m_iDeviceIndex;
	dlg.m_iMirrorNum = m_iMirrorNum;
	dlg.m_iStartChannel = m_iStartChannel;
	dlg.DoModal();
}

void DlgRecordHost::OnBtnSdiAutoTrack() 
{
	// TODO: Add your control notification handler code here
	DlgSDIAutoTrackCfg dlg;
	dlg.m_lUserID = m_lServerID;
	dlg.m_iDeviceIndex = m_iDeviceIndex;
	dlg.m_iMirrorNum = m_iMirrorNum;
	dlg.m_iStartChannel = m_iStartChannel;
	dlg.DoModal();
}

void DlgRecordHost::OnBtnPublishCfg() 
{
	// TODO: Add your control notification handler code here
	DlgRecordPublishCfg dlg;
	dlg.m_lUserID = m_lServerID;
	dlg.m_iDeviceIndex = m_iDeviceIndex;
	dlg.m_iMirrorNum = m_iMirrorNum;
	dlg.m_iStartChannel = m_iStartChannel;
	dlg.DoModal();
}

void DlgRecordHost::OnBtnRecordControl() 
{
	// TODO: Add your control notification handler code here
	DlgRecordControl dlg;
	dlg.m_lUserID = m_lServerID;
	dlg.m_iDeviceIndex = m_iDeviceIndex;
	dlg.m_iMirrorNum = m_iMirrorNum;
	dlg.m_iStartChannel = m_iStartChannel;
	dlg.DoModal();
}

void DlgRecordHost::OnBtnGetEndTime() 
{
	// TODO: Add your control notification handler code here
	DlgRecordHostEndTime dlg;
	dlg.m_lUserID = m_lServerID;
	dlg.m_iDeviceIndex = m_iDeviceIndex;
	dlg.m_iMirrorNum = m_iMirrorNum;
	dlg.m_iStartChannel = m_iStartChannel;
	dlg.DoModal();
}

void DlgRecordHost::OnBtnPublish() 
{
	// TODO: Add your control notification handler code here
	DlgOneKeyPublish dlg;
	dlg.m_lUserID = m_lServerID;
	dlg.m_iDeviceIndex = m_iDeviceIndex;
	dlg.m_iMirrorNum = m_iMirrorNum;
	dlg.m_iStartChannel = m_iStartChannel;
	dlg.DoModal();
}

void DlgRecordHost::OnBtnCourseCfg() 
{
	// TODO: Add your control notification handler code here
	DlgCourseInfo dlg;
	dlg.m_lUserID = m_lServerID;
	dlg.m_iDeviceIndex = m_iDeviceIndex;
	dlg.m_iMirrorNum = m_iMirrorNum;
	dlg.m_iStartChannel = m_iStartChannel;
	dlg.DoModal();
}

void DlgRecordHost::OnBtnCurriculumCfg() 
{
	// TODO: Add your control notification handler code here
	DlgCourseCfg dlg;
	dlg.m_lUserID = m_lServerID;
	dlg.m_iDeviceIndex = m_iDeviceIndex;
	dlg.m_iMirrorNum = m_iMirrorNum;
	dlg.m_iStartChannel = m_iStartChannel;
	dlg.DoModal();
}

#include "DlgPPTDetect.h"
void DlgRecordHost::OnBtnPptDetect() 
{
	// TODO: Add your control notification handler code here
	CDlgPPTDetect dlg;
	dlg.DoModal();
}
