// DlgTrialDVR.cpp : implementation file
//

#include "stdafx.h"
#include "clientdemo.h"
#include "DlgTrialDVR.h"
#include "DlgTrialAudioActivation.h"
#include "DlgInfrared.h"
#include "DlgTrialPIPCfg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgTrialDVR dialog


CDlgTrialDVR::CDlgTrialDVR(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgTrialDVR::IDD, pParent)
    ,m_lUserID(-1)
    ,m_iDevIndex(-1)

{
	//{{AFX_DATA_INIT(CDlgTrialDVR)
	m_wHDMINum = 0;
	m_wIPNum = 0;
	m_wPIPNum = 0;
	m_wSDINum = 0;
	m_wHDMIStartNo = 0;
	m_wIPStartNo = 0;
	m_wPIPStartNo = 0;
	m_wSDIStartNo = 0;
	m_wVGAStartNo = 0;
	m_wVGANum = 0;
	m_wPOEStartNo = 0;
	m_wYPBPRStartNo = 0;
	m_wPOENum = 0;
	m_wYPBPRNum = 0;
	//}}AFX_DATA_INIT
}


void CDlgTrialDVR::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgTrialDVR)
	DDX_Text(pDX, IDC_EDIT_HDMI_NUM, m_wHDMINum);
	DDX_Text(pDX, IDC_EDIT_IP_NUM, m_wIPNum);
	DDX_Text(pDX, IDC_EDIT_PIP_NUM, m_wPIPNum);
	DDX_Text(pDX, IDC_EDIT_SDI_NUM, m_wSDINum);
	DDX_Text(pDX, IDC_EDIT_START_NO_HDMI, m_wHDMIStartNo);
	DDX_Text(pDX, IDC_EDIT_START_NO_IP, m_wIPStartNo);
	DDX_Text(pDX, IDC_EDIT_START_NO_PIP, m_wPIPStartNo);
	DDX_Text(pDX, IDC_EDIT_START_NO_SDI, m_wSDIStartNo);
	DDX_Text(pDX, IDC_EDIT_START_NO_VGA, m_wVGAStartNo);
	DDX_Text(pDX, IDC_EDIT_VGA_NUM, m_wVGANum);
	DDX_Text(pDX, IDC_EDIT_START_NO_POE, m_wPOEStartNo);
	DDX_Text(pDX, IDC_EDIT_START_NO_YPBPR, m_wYPBPRStartNo);
	DDX_Text(pDX, IDC_EDIT_POE_NUM, m_wPOENum);
	DDX_Text(pDX, IDC_EDIT_YPBPR_NUM, m_wYPBPRNum);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgTrialDVR, CDialog)
	//{{AFX_MSG_MAP(CDlgTrialDVR)
	ON_BN_CLICKED(IDC_BTN_AUDIO_ACTIVATION, OnBtnAudioActivation)
	ON_BN_CLICKED(IDC_BTN_INFRARED, OnBtnInfrared)
	ON_BN_CLICKED(IDC_BTN_GET_SYSTEM_INFO, OnBtnGetSystemInfo)
	ON_BN_CLICKED(IDC_BTN_PIP_CFG, OnBtnPipCfg)
	ON_BN_CLICKED(IDC_BTN_REMOTE_PLAY, OnBtnRemotePlay)
	ON_BN_CLICKED(IDC_BTN_CASE_INFO, OnBtnCaseInfo)
	ON_BN_CLICKED(IDC_BTN_MICROPHONE_STATUS, OnBtnMicrophoneStatus)
	ON_BN_CLICKED(IDC_BTN_TRIAL_HOST_STATUS, OnBtnTrialHostStatus)
	ON_BN_CLICKED(IDC_BTN_LOCAL_INPUT, OnBtnLocalInput)
	ON_BN_CLICKED(IDC_BTN_LAMP_INFO, OnBtnLampInfo)
	ON_BN_CLICKED(IDC_BTN_LAMP_CONTROL, OnBtnLampControl)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgTrialDVR message handlers

void CDlgTrialDVR::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

void CDlgTrialDVR::OnBtnAudioActivation() 
{
	// TODO: Add your control notification handler code here
    CDlgTrialAudioActivation dlg;
    dlg.m_lUserID = m_lUserID;
    dlg.m_iDevIndex = m_iDevIndex;
    memcpy(&(dlg.m_struSystemInfo),&m_struTrialSysInfo,sizeof(m_struTrialSysInfo));
    dlg.DoModal();
}

void CDlgTrialDVR::OnBtnInfrared() 
{
	// TODO: Add your control notification handler code here
    CDlgInfrared dlg;
    dlg.m_lUserID = m_lUserID;
    dlg.m_iDevIndex = m_iDevIndex;
 
    dlg.DoModal();
}

void CDlgTrialDVR::OnBtnGetSystemInfo() 
{
	// TODO: Add your control notification handler code here
	memset(&m_struTrialSysInfo,0,sizeof(m_struTrialSysInfo));

    if (m_iDevIndex < 0)
    {
        return;
    }

    DWORD dwRet = 0 ;
    if (!NET_DVR_GetDVRConfig(m_lUserID,NET_DVR_GET_TRIAL_SYSTEM_CFG,NULL,&m_struTrialSysInfo,sizeof(m_struTrialSysInfo),&dwRet))
    {
        g_pMainDlg->AddLog(m_iDevIndex,OPERATION_FAIL_T,"NET_DVR_GET_TRIAL_SYSTEM_CFG");
        return;
    }
    else
    {
        g_pMainDlg->AddLog(m_iDevIndex,OPERATION_SUCC_T,"NET_DVR_GET_TRIAL_SYSTEM_CFG");
    }

    for (int i = 0; i < m_struTrialSysInfo.byVideoInTypeNum; i++)
    {
        switch (m_struTrialSysInfo.struVideoIn[i].wInType)
        {
        case 0:
            m_wSDINum = m_struTrialSysInfo.struVideoIn[i].wInNum;
            m_wSDIStartNo = m_struTrialSysInfo.struVideoIn[i].wStartNo;
            break;
        case  1:
            m_wVGANum = m_struTrialSysInfo.struVideoIn[i].wInNum;
            m_wVGAStartNo = m_struTrialSysInfo.struVideoIn[i].wStartNo;
            break;
        case 2:
            m_wHDMINum = m_struTrialSysInfo.struVideoIn[i].wInNum;
            m_wHDMIStartNo = m_struTrialSysInfo.struVideoIn[i].wStartNo;
            break;
        case 3:
            m_wIPNum = m_struTrialSysInfo.struVideoIn[i].wInNum;
            m_wIPStartNo = m_struTrialSysInfo.struVideoIn[i].wStartNo;
            break;
        case 4:
            m_wPIPNum = m_struTrialSysInfo.struVideoIn[i].wInNum;
            m_wPIPStartNo = m_struTrialSysInfo.struVideoIn[i].wStartNo;
            break;
        case 5:
            m_wPOENum = m_struTrialSysInfo.struVideoIn[i].wInNum;
            m_wPOEStartNo = m_struTrialSysInfo.struVideoIn[i].wStartNo;
            break;
        case 6:
            m_wYPBPRNum = m_struTrialSysInfo.struVideoIn[i].wInNum;
            m_wYPBPRStartNo = m_struTrialSysInfo.struVideoIn[i].wStartNo;
            break;
        default:
            break;
        }
    }
    
    UpdateData(FALSE);

}

BOOL CDlgTrialDVR::OnInitDialog() 
{
	CDialog::OnInitDialog();
	memset(&m_struTrialSysInfo,0,sizeof(m_struTrialSysInfo));
	// TODO: Add extra initialization here
	OnBtnGetSystemInfo();
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgTrialDVR::OnBtnPipCfg() 
{
	// TODO: Add your control notification handler code here
	CDlgTrialPIPCfg dlg;
    dlg.m_lUserID = m_lUserID;
    dlg.m_iDevIndex = m_iDevIndex;
       memcpy(&(dlg.m_struSystemInfo),&m_struTrialSysInfo,sizeof(m_struTrialSysInfo));
    dlg.DoModal();
}

#include "DlgRemoteControlPlay.h"
void CDlgTrialDVR::OnBtnRemotePlay() 
{
	// TODO: Add your control notification handler code here
	CDlgRemoteControlPlay dlg;
	dlg.DoModal();
}

#include "DlgCaseInfo.h"
void CDlgTrialDVR::OnBtnCaseInfo() 
{
	// TODO: Add your control notification handler code here
	CDlgCaseInfo dlg;
	dlg.DoModal();
}

#include "DlgMicrophoneStatus.h"
void CDlgTrialDVR::OnBtnMicrophoneStatus() 
{
	// TODO: Add your control notification handler code here
	CDlgMicrophoneStatus dlg;
	dlg.DoModal();
}

#include "DlgTrialHostStatus.h"
void CDlgTrialDVR::OnBtnTrialHostStatus() 
{
	// TODO: Add your control notification handler code here
	CDlgTrialHostStatus dlg;
	dlg.DoModal();
}

#include "DlgLocalInputInfo.h"
void CDlgTrialDVR::OnBtnLocalInput() 
{
	// TODO: Add your control notification handler code here
	CDlgLocalInputInfo dlg;
	dlg.setParam(m_struTrialSysInfo);
	dlg.DoModal();
}

#include "DlgLampCfg.h"
void CDlgTrialDVR::OnBtnLampInfo() 
{
	// TODO: Add your control notification handler code here
	CDlgLampCfg dlg;
	dlg.DoModal();
}

#include "DlgLampControl.h"
void CDlgTrialDVR::OnBtnLampControl() 
{
	// TODO: Add your control notification handler code here
	CDlgLampControl dlg;
	dlg.DoModal();
}
