// DlgVcaITCTriggerCfg.cpp : implementation file
//

#include "stdafx.h"
#include "clientdemo.h"
#include "DlgVcaITCTriggerCfg.h"
#include "DrawFun.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define MAX_POLYGON_POINT_NUM ITC_MAX_POLYGON_POINT_NUM
#define MIN_POLYGON_POINT_NUM 3

/////////////////////////////////////////////////////////////////////////////
// CDlgVcaITCTriggerCfg dialog

//CDlgVcaITCTriggerCfg *g_pDlgVcaITCTriggerCfg = NULL;

void CALLBACK g_DrawITCTriggerRgn(LONG lRealHandle, HDC hDc, DWORD dwUser)
{  
 	CDlgVcaITCTriggerCfg* pDlg = (CDlgVcaITCTriggerCfg*)dwUser;

 	if (pDlg != NULL)
 	{
 		pDlg->DrawRgnFun(hDc);
 	}
}

CDlgVcaITCTriggerCfg::CDlgVcaITCTriggerCfg(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgVcaITCTriggerCfg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgVcaITCTriggerCfg)
	m_bFarmVehicleRecog = FALSE;
	m_bMicroPlateRecog = FALSE;
	m_bPlateRecog = FALSE;
	m_bTriggerCfg = FALSE;
	m_bVehicleColorRecog = FALSE;
	m_bVehicleLogoRecog = FALSE;
	m_bViaVtcoil = FALSE;
	m_strProvinceName = _T("");
	m_bFuzzyRecog = FALSE;
	m_bMotocarRecog = FALSE;
	m_nAssociateLaneNO = 0;
	m_nLaneNum = 0;
	m_szSceneName = _T("");
	m_bEnable = FALSE;
	m_bIpcHvt = FALSE;
	//}}AFX_DATA_INIT

	memset(&m_struItcTriggerCfg,0,sizeof(m_struItcTriggerCfg));
	memset(&m_struCalibration,0,sizeof(m_struCalibration));
	memset(&m_szStatusBuf, 0, ISAPI_STATUS_LEN);
    m_nCurDrawType         =     DRAW_TYPE_NONE;
	m_bFirstDrawLaneBoundary = FALSE;
	m_bFirstDrawLaneLine = FALSE;
	m_nCurLaneIndex = 0;
	m_nDrawPointNum = 0;
	m_lPlayHandle = -1;
	m_iTriggerMode = 0;
}

CDlgVcaITCTriggerCfg::~CDlgVcaITCTriggerCfg()
{
//	StopRealPlay();
}

void CDlgVcaITCTriggerCfg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgVcaITCTriggerCfg)
	DDX_Control(pDX, IDC_COMBO_REGION_TYPE, m_comRegion);
	DDX_Control(pDX, IDC_COMBO_PROVINCE_TYPE, m_comProvince);
	DDX_Control(pDX, IDC_COMBO_DETSCENE_ID, m_comDetSceneID);
	DDX_Control(pDX, IDC_COMBO_IO_NO, m_comIONo);
	DDX_Control(pDX, IDC_COMBO_TRIGGER_TYPE, m_comTriggerType);
	DDX_Control(pDX, IDC_COMBO_RELATE_CHAN, m_comRelateChan);
	DDX_Control(pDX, IDC_COMBO_SOURCE_TYPE, m_comSourceType);
	DDX_Control(pDX, IDC_COMBO_TRIGGER_MODE, m_comTriggerMode);
	DDX_Control(pDX, IDC_COMBO_VEHICLE_TYPE, m_comboVehicleType);
	DDX_Control(pDX, IDC_COMBO_TIME_TYPE, m_comboTimeType);
	DDX_Control(pDX, IDC_COMBO_SCENE_TYPE, m_comboSceneType);
	DDX_Control(pDX, IDC_COMBO_RECOG_TYPE, m_comboRecogType);
	DDX_Control(pDX, IDC_COMBO_RECOG_POS, m_comboRecogPos);
	DDX_Control(pDX, IDC_COMBO_LOCATE_TYPE, m_comboLocateType);
	DDX_Control(pDX, IDC_COMBO_LANE_USEAGETYPE, m_comboLaneUseageType);
	DDX_Control(pDX, IDC_COMBO_LANE_NUMBER, m_comboLaneNumber);
	DDX_Control(pDX, IDC_COMBO_LANE_DIRECTION, m_comboLaneDirection);
	DDX_Control(pDX, IDC_COMBO_DRIVE_DIRECTION, m_comboDriveDirection);
	DDX_Control(pDX, IDC_COMBO_LANE_CAR_DRIVE_DIRECT, m_comboCarDriveDirect);
	DDX_Check(pDX, IDC_CHECK_FARM_VEHICLE_RECOG, m_bFarmVehicleRecog);
	DDX_Check(pDX, IDC_CHECK_MICRO_PLATE_RECOG, m_bMicroPlateRecog);
	DDX_Check(pDX, IDC_CHECK_PLATE_RECOG, m_bPlateRecog);
	DDX_Check(pDX, IDC_CHECK_TRIGGER_CFG, m_bTriggerCfg);
	DDX_Check(pDX, IDC_CHECK_VEHICLE_COLOR_RECOG, m_bVehicleColorRecog);
	DDX_Check(pDX, IDC_CHECK_VEHICLE_LOGO_RECOG, m_bVehicleLogoRecog);
	DDX_Check(pDX, IDC_CHECK_VIA_VTCOIL, m_bViaVtcoil);
	DDX_Text(pDX, IDC_EDIT_PROVINCE_NAME, m_strProvinceName);
	DDX_Check(pDX, IDC_CHECK_FUZZY_RECOG, m_bFuzzyRecog);
	DDX_Check(pDX, IDC_CHECK_MOTOCAR_RECOG, m_bMotocarRecog);
	DDX_Text(pDX, IDC_EDIT_ASSOCIATE_LANENO, m_nAssociateLaneNO);
	DDX_Text(pDX, IDC_EDIT_LANE_NUM, m_nLaneNum);
	DDX_Text(pDX, IDC_EDIT_SCENENAME, m_szSceneName);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgVcaITCTriggerCfg, CDialog)
	//{{AFX_MSG_MAP(CDlgVcaITCTriggerCfg)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BTN_DRAW_LANE_BOUNDARY_LINE, OnBtnDrawLaneBoundaryLine)
	ON_BN_CLICKED(IDC_BTN_DRAW_LANE_LINE, OnBtnDrawLaneLine)
	ON_BN_CLICKED(IDC_BTN_DRAW_PLATE_RECOG_RGN, OnBtnDrawPlateRecogRgn)
	ON_CBN_SELCHANGE(IDC_COMBO_LANE_NUMBER, OnSelchangeComboLaneNumber)
	ON_BN_CLICKED(IDC_BTN_SAVE, OnBtnSave)
	ON_WM_LBUTTONDOWN()
	ON_WM_RBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	ON_BN_CLICKED(IDC_BTN_END_DRAW, OnBtnEndDraw)
	ON_CBN_SELCHANGE(IDC_COMBO_TRIGGER_MODE, OnSelchangeComboTriggerMode)
	ON_CBN_SELCHANGE(IDC_COMBO_SOURCE_TYPE, OnSelchangeComboSourceType)
	ON_BN_CLICKED(IDC_BTN_GET, OnBtnGet)
	ON_BN_CLICKED(IDC_BTN_GET_CURTRIGGERMODE, OnBtnGetCurtriggermode)
	ON_BN_CLICKED(IDC_BTN_SET_CURTRIGGERMODE, OnBtnSetCurtriggermode)
	ON_BN_CLICKED(IDC_BTN_GET_CALIBRATION, OnBtnGetCalibration)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgVcaITCTriggerCfg message handlers
BOOL CDlgVcaITCTriggerCfg::OnInitDialog()
{
	CDialog::OnInitDialog();

	//g_pDlgVcaITCTriggerCfg = this;
	
    GetDlgItem(IDC_PLAYWND)->GetWindowRect(&m_rcPlayWnd);
	ScreenToClient(&m_rcPlayWnd);
//	m_comTriggerMode.SetCurSel(0);
//	OnSelchangeComboTriggerMode();
//	m_comSourceType.SetCurSel(0);
//	OnSelchangeComboSourceType();
//	StartRealPlay(GetDlgItem(IDC_PLAYWND)->GetSafeHwnd(),g_DrawITCTriggerRgn,this);
// 	NET_DVR_CURTRIGGERMODE struTrigCfg = {0};
// 	DWORD dwReturn = 0;
// 	if (!NET_DVR_GetDVRConfig(m_lServerID, NET_DVR_GET_CURTRIGGERMODE, m_lChannel, &struTrigCfg, sizeof(struTrigCfg), &dwReturn))
//     {
// 		g_pMainDlg->AddLog(m_iDevIndex, OPERATION_FAIL_T, "NET_ITC_GET_TRIGGERCFG Chan[%d]", m_lChannel);
//         return FALSE;
//     }
// 
// 	if (struTrigCfg.dwTriggerType == ITC_POST_MPR_TYPE )
// 	{
// 		m_comTriggerMode.SetCurSel(1);
// 	} 
// 	else if (struTrigCfg.dwTriggerType == IPC_POST_HVT_TYPE)
// 	{
//         m_comTriggerMode.SetCurSel(2);
// 	}
//     else
// 	{
// 		m_comTriggerMode.SetCurSel(0);
// 	}

    m_comTriggerMode.SetCurSel(0);
	m_comDetSceneID.SetCurSel(0);

    OnBtnGetCurtriggermode();

	OnSelchangeComboTriggerMode();

	//StartRealPlay();
	StartRealPlay(GetDlgItem(IDC_PLAYWND)->GetSafeHwnd(),g_DrawITCTriggerRgn,this);

	InitCtrlState();

	GetITCTriggerCfg();
	LoadWndContent();

	return TRUE;
}

void CDlgVcaITCTriggerCfg::OnDestroy()
{   
	StopRealPlay();
	CDialog::OnDestroy();
}

// long CDlgVcaITCTriggerCfg::StartRealPlay()
// {
// 	NET_DVR_CLIENTINFO struPlay;
// 	struPlay.hPlayWnd 	= GetDlgItem(IDC_PLAYWND)->GetSafeHwnd();
// 	struPlay.lChannel 	= m_lChannel; 
// 	struPlay.lLinkMode 	= 0;
// 	struPlay.sMultiCastIP = "";	
// 	if (m_lPlayHandle >= 0)
//     {
//         NET_DVR_StopRealPlay(m_lPlayHandle);
//     }
// 	m_lPlayHandle = NET_DVR_RealPlay_V30(m_lServerID, &struPlay, NULL, NULL, TRUE); 
// 	BOOL bRet = FALSE;
// 	if (m_lPlayHandle < 0)
// 	{
// 		g_pMainDlg->AddLog(m_iDevIndex, OPERATION_FAIL_T, "NET_DVR_RealPlay_V30");
// 		AfxMessageBox("NET_DVR_RealPlay_V30 FAIL");		
// 	}
// 	else
// 	{
// 		g_pMainDlg->AddLog(m_iDevIndex, OPERATION_SUCC_T, "NET_DVR_RealPlay_V30");
// 		bRet = NET_DVR_RigisterDrawFun(m_lPlayHandle, g_DrawITCTriggerRgn, 0);//DC Draw callback
// 	}
// 
//     return m_lPlayHandle;
// }
// 
// BOOL CDlgVcaITCTriggerCfg::StopRealPlay()
// {
//     BOOL bRet;
//     if (m_lPlayHandle >= 0)
//     {
//         bRet = NET_DVR_StopRealPlay(m_lPlayHandle);
//         if (!bRet)
//         {
//             AfxMessageBox("Fail to stop preview");
//         }
//     }
//     return bRet;
// }


void CDlgVcaITCTriggerCfg::OnBtnDrawLaneBoundaryLine() 
{

	if (0 == m_iTriggerMode)
	{
		NET_ITC_LINE& struLaneBoundaryLine = m_struItcTriggerCfg.struTriggerParam.uTriggerParam.struViaVtCoil.struLaneBoundaryLine;
		memset(&struLaneBoundaryLine,0,sizeof(struLaneBoundaryLine));
		m_bFirstDrawLaneBoundary = TRUE;
		m_nCurDrawType = DRAW_TYPE_LANE_BOUNDARY_LINE;
	}
	else if (1 == m_iTriggerMode)
	{
		NET_ITC_LINE& struLaneBoundaryLine = m_struItcTriggerCfg.struTriggerParam.uTriggerParam.struPostMpr.struLaneBoundaryLine;
		memset(&struLaneBoundaryLine,0,sizeof(struLaneBoundaryLine));
		m_bFirstDrawLaneBoundary = TRUE;
		m_nCurDrawType = DRAW_TYPE_LANE_BOUNDARY_LINE;
	}
	else if (2 == m_iTriggerMode)
    {
        NET_ITC_LINE& struLaneBoundaryLine = m_struItcTriggerCfg.struTriggerParam.uTriggerParam.struIpcHvt.struLaneBoundaryLine;
        memset(&struLaneBoundaryLine,0,sizeof(struLaneBoundaryLine));
        m_bFirstDrawLaneBoundary = TRUE;
		m_nCurDrawType = DRAW_TYPE_LANE_BOUNDARY_LINE; 
    }

}

void CDlgVcaITCTriggerCfg::OnBtnDrawLaneLine() 
{
	if (0 == m_iTriggerMode)
	{
		NET_ITC_LINE& struLaneLine = m_struItcTriggerCfg.struTriggerParam.uTriggerParam.struViaVtCoil.struLaneParam[m_nCurLaneIndex].struLaneLine;
		memset(&struLaneLine,0,sizeof(struLaneLine));
		m_bFirstDrawLaneLine = TRUE;
		m_nCurDrawType = DRAW_TYPE_LANE_LINE;
	}
	else if (1 == m_iTriggerMode)
	{
		NET_ITC_LINE& struLaneLine = m_struItcTriggerCfg.struTriggerParam.uTriggerParam.struPostMpr.struLaneParam[m_nCurLaneIndex].struLaneLine;
		memset(&struLaneLine,0,sizeof(struLaneLine));
		m_bFirstDrawLaneLine = TRUE;
		m_nCurDrawType = DRAW_TYPE_LANE_LINE;
	}
   	else if (2 == m_iTriggerMode)
    {
        NET_ITC_LINE& struLaneLine = m_struItcTriggerCfg.struTriggerParam.uTriggerParam.struIpcHvt.struLaneParam[m_nCurLaneIndex].struLaneLine;
        memset(&struLaneLine,0,sizeof(struLaneLine));
        m_bFirstDrawLaneLine = TRUE;
		m_nCurDrawType = DRAW_TYPE_LANE_LINE;
    }
}

void CDlgVcaITCTriggerCfg::OnBtnDrawPlateRecogRgn() 
{   
	if (0 == m_iTriggerMode)
	{
		NET_ITC_POLYGON&  struPlateRecog = m_struItcTriggerCfg.struTriggerParam.uTriggerParam.struViaVtCoil.struLaneParam[m_nCurLaneIndex].struPlateRecog;
		memset(&struPlateRecog,0,sizeof(struPlateRecog));
		m_nCurDrawType = DRAW_TYPE_PLATE_RECOG_RGN;
		m_nDrawPointNum = 0;
	}
	else if (1 == m_iTriggerMode)
	{
		NET_ITC_POLYGON&  struPlateRecog = m_struItcTriggerCfg.struTriggerParam.uTriggerParam.struPostMpr.struLaneParam[m_nCurLaneIndex].struPlateRecog;
		memset(&struPlateRecog,0,sizeof(struPlateRecog));
		m_nCurDrawType = DRAW_TYPE_PLATE_RECOG_RGN;
		m_nDrawPointNum = 0;
	}
    else if (2 == m_iTriggerMode)
    {
        NET_ITC_POLYGON&  struPlateRecog = m_struItcTriggerCfg.struTriggerParam.uTriggerParam.struIpcHvt.struLaneParam[m_nCurLaneIndex].struPlateRecog;
        memset(&struPlateRecog,0,sizeof(struPlateRecog));
        m_nCurDrawType = DRAW_TYPE_PLATE_RECOG_RGN;
		m_nDrawPointNum = 0;
    }
}

void CDlgVcaITCTriggerCfg::OnBtnEndDraw() 
{   
	if (m_nCurDrawType == DRAW_TYPE_PLATE_RECOG_RGN)
	{
		
		if (0 == m_iTriggerMode)
		{
			NET_ITC_POLYGON&  struPlateRecog = m_struItcTriggerCfg.struTriggerParam.uTriggerParam.struViaVtCoil.struLaneParam[m_nCurLaneIndex].struPlateRecog;
			if (m_nDrawPointNum >= MIN_POLYGON_POINT_NUM)
			{
				struPlateRecog.dwPointNum = m_nDrawPointNum;
			}
			else
			{
				
				memset(&struPlateRecog,0,sizeof(struPlateRecog));
			}
			m_nCurDrawType = DRAW_TYPE_NONE;
		}
		else if (1 == m_iTriggerMode)
		{
			NET_ITC_POLYGON&  struPlateRecog = m_struItcTriggerCfg.struTriggerParam.uTriggerParam.struPostMpr.struLaneParam[m_nCurLaneIndex].struPlateRecog;
			if (m_nDrawPointNum >= MIN_POLYGON_POINT_NUM)
			{
				struPlateRecog.dwPointNum = m_nDrawPointNum;
			}
			else
			{
				
				memset(&struPlateRecog,0,sizeof(struPlateRecog));
			}
			m_nCurDrawType = DRAW_TYPE_NONE;
		}
        else if (2 == m_iTriggerMode)
		{
            NET_ITC_POLYGON&  struPlateRecog = m_struItcTriggerCfg.struTriggerParam.uTriggerParam.struIpcHvt.struLaneParam[m_nCurLaneIndex].struPlateRecog;
            if (m_nDrawPointNum >= MIN_POLYGON_POINT_NUM)
            {
                struPlateRecog.dwPointNum = m_nDrawPointNum;
            }
            else
            {
                
                memset(&struPlateRecog,0,sizeof(struPlateRecog));
            }
			m_nCurDrawType = DRAW_TYPE_NONE;
        }
	}
}

void CDlgVcaITCTriggerCfg::OnSelchangeComboLaneNumber() 
{
	int nCurSel = m_comboLaneNumber.GetCurSel();
	if (nCurSel != CB_ERR)
	{   
		UpdateData(TRUE);
		SaveViaLaneWndContent(m_nCurLaneIndex);
		m_nCurLaneIndex = nCurSel;
		LoadViaLaneWndContent(nCurSel);
		UpdateData(FALSE);
	}
}

void CDlgVcaITCTriggerCfg::OnBtnSave() 
{
	SaveWndContent();
    
	char szError[32] = "\0";
	if (SetITCTriggerCfg())
	{
		g_StringLanType(szError, "ɹ","Saved successfully");
	}
	else
	{
		g_StringLanType(szError, "ʧ","Save failed");
	}
	AfxMessageBox(szError);
}


void CDlgVcaITCTriggerCfg::OnLButtonDown(UINT nFlags, CPoint point)
{
	CDialog::OnLButtonDown(nFlags,point);

	if (!m_rcPlayWnd.PtInRect(point))
	{
		return;
	}
	if (m_nCurDrawType == DRAW_TYPE_NONE)
	{
		return;
	}
	
	if (m_nCurDrawType == DRAW_TYPE_LANE_LINE)
	{
		if (0 == m_iTriggerMode)
		{
			NET_ITC_LINE& struLaneLine = m_struItcTriggerCfg.struTriggerParam.uTriggerParam.struViaVtCoil.struLaneParam[m_nCurLaneIndex].struLaneLine;
			if (m_bFirstDrawLaneLine)
			{
				struLaneLine.struLine.struStart.fX = (float)(point.x-m_rcPlayWnd.left)/(float)m_rcPlayWnd.Width();
				struLaneLine.struLine.struStart.fY = (float)(point.y-m_rcPlayWnd.top) /(float)m_rcPlayWnd.Height();
				struLaneLine.struLine.struEnd.fX   = struLaneLine.struLine.struStart.fX;
				struLaneLine.struLine.struEnd.fY   = struLaneLine.struLine.struStart.fY;
				m_bFirstDrawLaneLine= FALSE;
			}
			else
			{   
				struLaneLine.struLine.struEnd.fX = (float)(point.x-m_rcPlayWnd.left)/(float)m_rcPlayWnd.Width();
				struLaneLine.struLine.struEnd.fY = (float)(point.y-m_rcPlayWnd.top) /(float)m_rcPlayWnd.Height();
				m_nCurDrawType = DRAW_TYPE_NONE;
			}
		}
		else if (1 == m_iTriggerMode)
		{
			NET_ITC_LINE& struLaneLine = m_struItcTriggerCfg.struTriggerParam.uTriggerParam.struPostMpr.struLaneParam[m_nCurLaneIndex].struLaneLine;
			if (m_bFirstDrawLaneLine)
			{
				struLaneLine.struLine.struStart.fX = (float)(point.x-m_rcPlayWnd.left)/(float)m_rcPlayWnd.Width();
				struLaneLine.struLine.struStart.fY = (float)(point.y-m_rcPlayWnd.top) /(float)m_rcPlayWnd.Height();
				struLaneLine.struLine.struEnd.fX   = struLaneLine.struLine.struStart.fX;
				struLaneLine.struLine.struEnd.fY   = struLaneLine.struLine.struStart.fY;
				m_bFirstDrawLaneLine= FALSE;
			}
			else
			{   
				struLaneLine.struLine.struEnd.fX = (float)(point.x-m_rcPlayWnd.left)/(float)m_rcPlayWnd.Width();
				struLaneLine.struLine.struEnd.fY = (float)(point.y-m_rcPlayWnd.top) /(float)m_rcPlayWnd.Height();
				m_nCurDrawType = DRAW_TYPE_NONE;
			}
		}
		else if (2 == m_iTriggerMode)
        {
            NET_ITC_LINE& struLaneLine = m_struItcTriggerCfg.struTriggerParam.uTriggerParam.struIpcHvt.struLaneParam[m_nCurLaneIndex].struLaneLine;
            if (m_bFirstDrawLaneLine)
            {
                struLaneLine.struLine.struStart.fX = (float)(point.x-m_rcPlayWnd.left)/(float)m_rcPlayWnd.Width();
                struLaneLine.struLine.struStart.fY = (float)(point.y-m_rcPlayWnd.top) /(float)m_rcPlayWnd.Height();
                struLaneLine.struLine.struEnd.fX   = struLaneLine.struLine.struStart.fX;
                struLaneLine.struLine.struEnd.fY   = struLaneLine.struLine.struStart.fY;
                m_bFirstDrawLaneLine= FALSE;
            }
            else
            {   
                struLaneLine.struLine.struEnd.fX = (float)(point.x-m_rcPlayWnd.left)/(float)m_rcPlayWnd.Width();
                struLaneLine.struLine.struEnd.fY = (float)(point.y-m_rcPlayWnd.top) /(float)m_rcPlayWnd.Height();
                m_nCurDrawType = DRAW_TYPE_NONE;
			}
        }
	
	}
	else if (m_nCurDrawType == DRAW_TYPE_LANE_BOUNDARY_LINE)
	{   
		if (0 == m_iTriggerMode)
		{
			NET_ITC_LINE& struLaneBoundaryLine = m_struItcTriggerCfg.struTriggerParam.uTriggerParam.struViaVtCoil.struLaneBoundaryLine;
			if (m_bFirstDrawLaneBoundary)
			{
				struLaneBoundaryLine.struLine.struStart.fX = (float)(point.x-m_rcPlayWnd.left)/(float)m_rcPlayWnd.Width();
				struLaneBoundaryLine.struLine.struStart.fY = (float)(point.y-m_rcPlayWnd.top) /(float)m_rcPlayWnd.Height();
				struLaneBoundaryLine.struLine.struEnd.fX   = struLaneBoundaryLine.struLine.struStart.fX;
				struLaneBoundaryLine.struLine.struEnd.fY   = struLaneBoundaryLine.struLine.struStart.fY;
				m_bFirstDrawLaneBoundary = FALSE;
			}
			else
			{   
				struLaneBoundaryLine.struLine.struEnd.fX = (float)(point.x-m_rcPlayWnd.left)/(float)m_rcPlayWnd.Width();
				struLaneBoundaryLine.struLine.struEnd.fY = (float)(point.y-m_rcPlayWnd.top) /(float)m_rcPlayWnd.Height();
				m_nCurDrawType = DRAW_TYPE_NONE;
			}
		}
		else if (1 == m_iTriggerMode)
		{
			NET_ITC_LINE& struLaneBoundaryLine = m_struItcTriggerCfg.struTriggerParam.uTriggerParam.struPostMpr.struLaneBoundaryLine;
			if (m_bFirstDrawLaneBoundary)
			{
				struLaneBoundaryLine.struLine.struStart.fX = (float)(point.x-m_rcPlayWnd.left)/(float)m_rcPlayWnd.Width();
				struLaneBoundaryLine.struLine.struStart.fY = (float)(point.y-m_rcPlayWnd.top) /(float)m_rcPlayWnd.Height();
				struLaneBoundaryLine.struLine.struEnd.fX   = struLaneBoundaryLine.struLine.struStart.fX;
				struLaneBoundaryLine.struLine.struEnd.fY   = struLaneBoundaryLine.struLine.struStart.fY;
				m_bFirstDrawLaneBoundary = FALSE;
			}
			else
			{   
				struLaneBoundaryLine.struLine.struEnd.fX = (float)(point.x-m_rcPlayWnd.left)/(float)m_rcPlayWnd.Width();
				struLaneBoundaryLine.struLine.struEnd.fY = (float)(point.y-m_rcPlayWnd.top) /(float)m_rcPlayWnd.Height();
				m_nCurDrawType = DRAW_TYPE_NONE;
			}
		}
        else if (2 == m_iTriggerMode)
        {
            NET_ITC_LINE& struLaneBoundaryLine = m_struItcTriggerCfg.struTriggerParam.uTriggerParam.struIpcHvt.struLaneBoundaryLine;
            if (m_bFirstDrawLaneBoundary)
            {
                struLaneBoundaryLine.struLine.struStart.fX = (float)(point.x-m_rcPlayWnd.left)/(float)m_rcPlayWnd.Width();
                struLaneBoundaryLine.struLine.struStart.fY = (float)(point.y-m_rcPlayWnd.top) /(float)m_rcPlayWnd.Height();
                struLaneBoundaryLine.struLine.struEnd.fX   = struLaneBoundaryLine.struLine.struStart.fX;
                struLaneBoundaryLine.struLine.struEnd.fY   = struLaneBoundaryLine.struLine.struStart.fY;
                m_bFirstDrawLaneBoundary = FALSE;
            }
            else
            {   
                struLaneBoundaryLine.struLine.struEnd.fX = (float)(point.x-m_rcPlayWnd.left)/(float)m_rcPlayWnd.Width();
                struLaneBoundaryLine.struLine.struEnd.fY = (float)(point.y-m_rcPlayWnd.top) /(float)m_rcPlayWnd.Height();
                m_nCurDrawType = DRAW_TYPE_NONE;
			}
        }
	}
	else if (m_nCurDrawType == DRAW_TYPE_PLATE_RECOG_RGN)
	{
		if (m_nDrawPointNum >= MAX_POLYGON_POINT_NUM)
		{
			m_nCurDrawType = DRAW_TYPE_NONE;
		}
		else
		{   
			if (0 == m_iTriggerMode)
			{
				NET_ITC_POLYGON&  struPlateRecog = m_struItcTriggerCfg.struTriggerParam.uTriggerParam.struViaVtCoil.struLaneParam[m_nCurLaneIndex].struPlateRecog;
				if(GetAsyncKeyState(VK_LCONTROL)<0 || GetAsyncKeyState(VK_RCONTROL)<0)//CTRL ͼ
				{
					if (m_nDrawPointNum == 1)
					{
						struPlateRecog.struPos[m_nDrawPointNum].fX = struPlateRecog.struPos[m_nDrawPointNum-1].fX;
						struPlateRecog.struPos[m_nDrawPointNum].fY  = (float)(point.y - m_rcPlayWnd.top)  / (float)m_rcPlayWnd.Height();
						
						struPlateRecog.struPos[m_nDrawPointNum+1].fX  = (float)(point.x - m_rcPlayWnd.left) / (float)m_rcPlayWnd.Width();
						struPlateRecog.struPos[m_nDrawPointNum+1].fY  = (float)(point.y - m_rcPlayWnd.top)  / (float)m_rcPlayWnd.Height();
						
						struPlateRecog.struPos[m_nDrawPointNum+2].fX = struPlateRecog.struPos[m_nDrawPointNum+1].fX;
						struPlateRecog.struPos[m_nDrawPointNum+2].fY = struPlateRecog.struPos[0].fY;
						
						m_nDrawPointNum = 4;
					}
					else if (m_nDrawPointNum == 0)
					{
						struPlateRecog.struPos[m_nDrawPointNum].fX  = (float)(point.x - m_rcPlayWnd.left) / (float)m_rcPlayWnd.Width();
						struPlateRecog.struPos[m_nDrawPointNum].fY  = (float)(point.y - m_rcPlayWnd.top)  / (float)m_rcPlayWnd.Height();
						m_nDrawPointNum = 1;
					}
				}
				else
				{
					struPlateRecog.struPos[m_nDrawPointNum].fX  = (float)(point.x - m_rcPlayWnd.left) / (float)m_rcPlayWnd.Width();
					struPlateRecog.struPos[m_nDrawPointNum].fY  = (float)(point.y - m_rcPlayWnd.top)  / (float)m_rcPlayWnd.Height();
					m_nDrawPointNum++;
				}
			}
			else if (1 == m_iTriggerMode)
			{
				NET_ITC_POLYGON&  struPlateRecog = m_struItcTriggerCfg.struTriggerParam.uTriggerParam.struPostMpr.struLaneParam[m_nCurLaneIndex].struPlateRecog;
				if(GetAsyncKeyState(VK_LCONTROL)<0 || GetAsyncKeyState(VK_RCONTROL)<0)//CTRL ͼ
				{
					if (m_nDrawPointNum == 1)
					{
						struPlateRecog.struPos[m_nDrawPointNum].fX = struPlateRecog.struPos[m_nDrawPointNum-1].fX;
						struPlateRecog.struPos[m_nDrawPointNum].fY  = (float)(point.y - m_rcPlayWnd.top)  / (float)m_rcPlayWnd.Height();
						
						struPlateRecog.struPos[m_nDrawPointNum+1].fX  = (float)(point.x - m_rcPlayWnd.left) / (float)m_rcPlayWnd.Width();
						struPlateRecog.struPos[m_nDrawPointNum+1].fY  = (float)(point.y - m_rcPlayWnd.top)  / (float)m_rcPlayWnd.Height();
						
						struPlateRecog.struPos[m_nDrawPointNum+2].fX = struPlateRecog.struPos[m_nDrawPointNum+1].fX;
						struPlateRecog.struPos[m_nDrawPointNum+2].fY = struPlateRecog.struPos[0].fY;
						
						m_nDrawPointNum = 4;
					}
					else if (m_nDrawPointNum == 0)
					{
						struPlateRecog.struPos[m_nDrawPointNum].fX  = (float)(point.x - m_rcPlayWnd.left) / (float)m_rcPlayWnd.Width();
						struPlateRecog.struPos[m_nDrawPointNum].fY  = (float)(point.y - m_rcPlayWnd.top)  / (float)m_rcPlayWnd.Height();
						m_nDrawPointNum = 1;
					}
				}
				else
				{
					struPlateRecog.struPos[m_nDrawPointNum].fX  = (float)(point.x - m_rcPlayWnd.left) / (float)m_rcPlayWnd.Width();
					struPlateRecog.struPos[m_nDrawPointNum].fY  = (float)(point.y - m_rcPlayWnd.top)  / (float)m_rcPlayWnd.Height();
					m_nDrawPointNum++;
				}
			}
            else if (2 == m_iTriggerMode)
            {
                NET_ITC_POLYGON&  struPlateRecog = m_struItcTriggerCfg.struTriggerParam.uTriggerParam.struIpcHvt.struLaneParam[m_nCurLaneIndex].struPlateRecog;
                if(GetAsyncKeyState(VK_LCONTROL)<0 || GetAsyncKeyState(VK_RCONTROL)<0)//CTRL ͼ
                {
                    if (m_nDrawPointNum == 1)
                    {
                        struPlateRecog.struPos[m_nDrawPointNum].fX = struPlateRecog.struPos[m_nDrawPointNum-1].fX;
                        struPlateRecog.struPos[m_nDrawPointNum].fY  = (float)(point.y - m_rcPlayWnd.top)  / (float)m_rcPlayWnd.Height();
                        
                        struPlateRecog.struPos[m_nDrawPointNum+1].fX  = (float)(point.x - m_rcPlayWnd.left) / (float)m_rcPlayWnd.Width();
                        struPlateRecog.struPos[m_nDrawPointNum+1].fY  = (float)(point.y - m_rcPlayWnd.top)  / (float)m_rcPlayWnd.Height();
                        
                        struPlateRecog.struPos[m_nDrawPointNum+2].fX = struPlateRecog.struPos[m_nDrawPointNum+1].fX;
                        struPlateRecog.struPos[m_nDrawPointNum+2].fY = struPlateRecog.struPos[0].fY;
                        
                        m_nDrawPointNum = 4;
                    }
                    else if (m_nDrawPointNum == 0)
                    {
                        struPlateRecog.struPos[m_nDrawPointNum].fX  = (float)(point.x - m_rcPlayWnd.left) / (float)m_rcPlayWnd.Width();
                        struPlateRecog.struPos[m_nDrawPointNum].fY  = (float)(point.y - m_rcPlayWnd.top)  / (float)m_rcPlayWnd.Height();
                        m_nDrawPointNum = 1;
                    }
                }
                else
                {
                    struPlateRecog.struPos[m_nDrawPointNum].fX  = (float)(point.x - m_rcPlayWnd.left) / (float)m_rcPlayWnd.Width();
                    struPlateRecog.struPos[m_nDrawPointNum].fY  = (float)(point.y - m_rcPlayWnd.top)  / (float)m_rcPlayWnd.Height();
                    m_nDrawPointNum++;
				}
            }
		}
	}
}

void CDlgVcaITCTriggerCfg::OnRButtonDown(UINT nFlags, CPoint point)
{
	CDialog::OnRButtonDown(nFlags,point);
	
	if (!m_rcPlayWnd.PtInRect(point))
	{
		return;
	}
	if (m_nCurDrawType == DRAW_TYPE_NONE)
	{
		return;
	}
	
	if (m_nCurDrawType == DRAW_TYPE_LANE_BOUNDARY_LINE)
	{   
		m_bFirstDrawLaneBoundary = FALSE;
	}
	else if (m_nCurDrawType == DRAW_TYPE_LANE_LINE)
	{
		m_bFirstDrawLaneLine = FALSE;
	}
	else if (m_nCurDrawType == DRAW_TYPE_PLATE_RECOG_RGN)
	{  
		if (0 == m_iTriggerMode)
		{
			NET_ITC_POLYGON& struPlateRecog = m_struItcTriggerCfg.struTriggerParam.uTriggerParam.struViaVtCoil.struLaneParam[m_nCurLaneIndex].struPlateRecog;
			if (m_nDrawPointNum < MIN_POLYGON_POINT_NUM)
			{
				memset(&struPlateRecog,0,sizeof(struPlateRecog));
			}
			else
			{   
				struPlateRecog.dwPointNum = m_nDrawPointNum;
			}
		}
		else if (1 == m_iTriggerMode)
		{
			NET_ITC_POLYGON& struPlateRecog = m_struItcTriggerCfg.struTriggerParam.uTriggerParam.struPostMpr.struLaneParam[m_nCurLaneIndex].struPlateRecog;
			if (m_nDrawPointNum < MIN_POLYGON_POINT_NUM)
			{
				memset(&struPlateRecog,0,sizeof(struPlateRecog));
			}
			else
			{   
				struPlateRecog.dwPointNum = m_nDrawPointNum;
			}
		}
        else if (2 == m_iTriggerMode)
        {
            NET_ITC_POLYGON& struPlateRecog = m_struItcTriggerCfg.struTriggerParam.uTriggerParam.struIpcHvt.struLaneParam[m_nCurLaneIndex].struPlateRecog;
            if (m_nDrawPointNum < MIN_POLYGON_POINT_NUM)
            {
                memset(&struPlateRecog,0,sizeof(struPlateRecog));
            }
            else
            {   
                struPlateRecog.dwPointNum = m_nDrawPointNum;
			}
        }
	}
	m_nCurDrawType = DRAW_TYPE_NONE;	
}

void CDlgVcaITCTriggerCfg::OnMouseMove(UINT nFlags, CPoint point)
{
	CDialog::OnMouseMove(nFlags,point);
	
	if (!m_rcPlayWnd.PtInRect(point))
	{
		return;
	}
	if (m_nCurDrawType == DRAW_TYPE_NONE)
	{
		return;
	}

	if (m_nCurDrawType == DRAW_TYPE_LANE_BOUNDARY_LINE)
	{   
		if (0 == m_iTriggerMode)
		{
			NET_ITC_LINE& struLaneBoundaryLine = m_struItcTriggerCfg.struTriggerParam.uTriggerParam.struViaVtCoil.struLaneBoundaryLine;
			if (!m_bFirstDrawLaneBoundary)
			{
				struLaneBoundaryLine.struLine.struEnd.fX = (float)(point.x-m_rcPlayWnd.left)/(float)m_rcPlayWnd.Width();
				struLaneBoundaryLine.struLine.struEnd.fY = (float)(point.y-m_rcPlayWnd.top) /(float)m_rcPlayWnd.Height();
			}
		}
		else if (1 == m_iTriggerMode)
		{
			NET_ITC_LINE& struLaneBoundaryLine = m_struItcTriggerCfg.struTriggerParam.uTriggerParam.struPostMpr.struLaneBoundaryLine;
			if (!m_bFirstDrawLaneBoundary)
			{
				struLaneBoundaryLine.struLine.struEnd.fX = (float)(point.x-m_rcPlayWnd.left)/(float)m_rcPlayWnd.Width();
				struLaneBoundaryLine.struLine.struEnd.fY = (float)(point.y-m_rcPlayWnd.top) /(float)m_rcPlayWnd.Height();
			}
		}
        else if (2 == m_iTriggerMode)
        {
            NET_ITC_LINE& struLaneBoundaryLine = m_struItcTriggerCfg.struTriggerParam.uTriggerParam.struIpcHvt.struLaneBoundaryLine;
            if (!m_bFirstDrawLaneBoundary)
            {
                struLaneBoundaryLine.struLine.struEnd.fX = (float)(point.x-m_rcPlayWnd.left)/(float)m_rcPlayWnd.Width();
                struLaneBoundaryLine.struLine.struEnd.fY = (float)(point.y-m_rcPlayWnd.top) /(float)m_rcPlayWnd.Height();
            }
		}
	}
	else if (m_nCurDrawType == DRAW_TYPE_LANE_LINE)
	{
		if (0 == m_iTriggerMode)
		{
			NET_ITC_LINE& struLaneLine = m_struItcTriggerCfg.struTriggerParam.uTriggerParam.struViaVtCoil.struLaneParam[m_nCurLaneIndex].struLaneLine;
			if (!m_bFirstDrawLaneLine)
			{
				struLaneLine.struLine.struEnd.fX = (float)(point.x-m_rcPlayWnd.left)/(float)m_rcPlayWnd.Width();
				struLaneLine.struLine.struEnd.fY = (float)(point.y-m_rcPlayWnd.top) /(float)m_rcPlayWnd.Height();
			}
		}
		else if (1 == m_iTriggerMode)
		{
			NET_ITC_LINE& struLaneLine = m_struItcTriggerCfg.struTriggerParam.uTriggerParam.struPostMpr.struLaneParam[m_nCurLaneIndex].struLaneLine;
			if (!m_bFirstDrawLaneLine)
			{
				struLaneLine.struLine.struEnd.fX = (float)(point.x-m_rcPlayWnd.left)/(float)m_rcPlayWnd.Width();
				struLaneLine.struLine.struEnd.fY = (float)(point.y-m_rcPlayWnd.top) /(float)m_rcPlayWnd.Height();
			}
		}
        else if (2 == m_iTriggerMode)
        {
            NET_ITC_LINE& struLaneLine = m_struItcTriggerCfg.struTriggerParam.uTriggerParam.struIpcHvt.struLaneParam[m_nCurLaneIndex].struLaneLine;
            if (!m_bFirstDrawLaneLine)
            {
                struLaneLine.struLine.struEnd.fX = (float)(point.x-m_rcPlayWnd.left)/(float)m_rcPlayWnd.Width();
                struLaneLine.struLine.struEnd.fY = (float)(point.y-m_rcPlayWnd.top) /(float)m_rcPlayWnd.Height();
            }
		}
	}
	else if (m_nCurDrawType == DRAW_TYPE_PLATE_RECOG_RGN)
	{   
		if (m_nDrawPointNum >= MAX_POLYGON_POINT_NUM || m_nDrawPointNum < 1)
		{
			return;
		}

		if (0 == m_iTriggerMode)
		{
			NET_ITC_POLYGON& struPlateRecog = m_struItcTriggerCfg.struTriggerParam.uTriggerParam.struViaVtCoil.struLaneParam[m_nCurLaneIndex].struPlateRecog;
			if(GetAsyncKeyState(VK_LCONTROL)<0 || GetAsyncKeyState(VK_RCONTROL)<0)//CTRL ͼ
			{
				if (m_nDrawPointNum == 1)
				{
					struPlateRecog.struPos[m_nDrawPointNum].fX = struPlateRecog.struPos[m_nDrawPointNum-1].fX;
					struPlateRecog.struPos[m_nDrawPointNum].fY  = (float)(point.y - m_rcPlayWnd.top)  / (float)m_rcPlayWnd.Height();
					
					struPlateRecog.struPos[m_nDrawPointNum+1].fX  = (float)(point.x - m_rcPlayWnd.left) / (float)m_rcPlayWnd.Width();
					struPlateRecog.struPos[m_nDrawPointNum+1].fY  = (float)(point.y - m_rcPlayWnd.top)  / (float)m_rcPlayWnd.Height();
					
					struPlateRecog.struPos[m_nDrawPointNum+2].fX = struPlateRecog.struPos[m_nDrawPointNum+1].fX;
					struPlateRecog.struPos[m_nDrawPointNum+2].fY = struPlateRecog.struPos[0].fY;
					
					struPlateRecog.dwPointNum = 4;
				}
			}
			else
			{
				struPlateRecog.struPos[m_nDrawPointNum].fX  = (float)(point.x - m_rcPlayWnd.left) / (float)m_rcPlayWnd.Width();
				struPlateRecog.struPos[m_nDrawPointNum].fY  = (float)(point.y - m_rcPlayWnd.top)  / (float)m_rcPlayWnd.Height();
				struPlateRecog.dwPointNum = m_nDrawPointNum + 1;
			}
		}
		else if (1 == m_iTriggerMode)
		{
			NET_ITC_POLYGON& struPlateRecog = m_struItcTriggerCfg.struTriggerParam.uTriggerParam.struPostMpr.struLaneParam[m_nCurLaneIndex].struPlateRecog;
			if(GetAsyncKeyState(VK_LCONTROL)<0 || GetAsyncKeyState(VK_RCONTROL)<0)//CTRL ͼ
			{
				if (m_nDrawPointNum == 1)
				{
					struPlateRecog.struPos[m_nDrawPointNum].fX = struPlateRecog.struPos[m_nDrawPointNum-1].fX;
					struPlateRecog.struPos[m_nDrawPointNum].fY  = (float)(point.y - m_rcPlayWnd.top)  / (float)m_rcPlayWnd.Height();
					
					struPlateRecog.struPos[m_nDrawPointNum+1].fX  = (float)(point.x - m_rcPlayWnd.left) / (float)m_rcPlayWnd.Width();
					struPlateRecog.struPos[m_nDrawPointNum+1].fY  = (float)(point.y - m_rcPlayWnd.top)  / (float)m_rcPlayWnd.Height();
					
					struPlateRecog.struPos[m_nDrawPointNum+2].fX = struPlateRecog.struPos[m_nDrawPointNum+1].fX;
					struPlateRecog.struPos[m_nDrawPointNum+2].fY = struPlateRecog.struPos[0].fY;
					
					struPlateRecog.dwPointNum = 4;
				}
			}
			else
			{
				struPlateRecog.struPos[m_nDrawPointNum].fX  = (float)(point.x - m_rcPlayWnd.left) / (float)m_rcPlayWnd.Width();
				struPlateRecog.struPos[m_nDrawPointNum].fY  = (float)(point.y - m_rcPlayWnd.top)  / (float)m_rcPlayWnd.Height();
				struPlateRecog.dwPointNum = m_nDrawPointNum + 1;
			}
		}
        else if (2 == m_iTriggerMode)
        {
            NET_ITC_POLYGON& struPlateRecog = m_struItcTriggerCfg.struTriggerParam.uTriggerParam.struIpcHvt.struLaneParam[m_nCurLaneIndex].struPlateRecog;
            if(GetAsyncKeyState(VK_LCONTROL)<0 || GetAsyncKeyState(VK_RCONTROL)<0)//CTRL ͼ
            {
                if (m_nDrawPointNum == 1)
                {
                    struPlateRecog.struPos[m_nDrawPointNum].fX = struPlateRecog.struPos[m_nDrawPointNum-1].fX;
                    struPlateRecog.struPos[m_nDrawPointNum].fY  = (float)(point.y - m_rcPlayWnd.top)  / (float)m_rcPlayWnd.Height();
                    
                    struPlateRecog.struPos[m_nDrawPointNum+1].fX  = (float)(point.x - m_rcPlayWnd.left) / (float)m_rcPlayWnd.Width();
                    struPlateRecog.struPos[m_nDrawPointNum+1].fY  = (float)(point.y - m_rcPlayWnd.top)  / (float)m_rcPlayWnd.Height();
                    
                    struPlateRecog.struPos[m_nDrawPointNum+2].fX = struPlateRecog.struPos[m_nDrawPointNum+1].fX;
                    struPlateRecog.struPos[m_nDrawPointNum+2].fY = struPlateRecog.struPos[0].fY;
                    
                    struPlateRecog.dwPointNum = 4;
                }
            }
            else
            {
                struPlateRecog.struPos[m_nDrawPointNum].fX  = (float)(point.x - m_rcPlayWnd.left) / (float)m_rcPlayWnd.Width();
                struPlateRecog.struPos[m_nDrawPointNum].fY  = (float)(point.y - m_rcPlayWnd.top)  / (float)m_rcPlayWnd.Height();
                struPlateRecog.dwPointNum = m_nDrawPointNum + 1;
            }
		}
	}
}

void CDlgVcaITCTriggerCfg::InitCtrlState()
{   
	char szText[32] = "\0";

	m_comboRecogPos.ResetContent();
    g_StringLanType(szText, "ʶ","Forward Plate");
	m_comboRecogPos.InsertString(0,szText);
	m_comboRecogPos.SetItemData(0,0);
    g_StringLanType(szText, "ʶ","Back Plate");
	m_comboRecogPos.InsertString(1,szText);
	m_comboRecogPos.SetItemData(1,1);
	m_comboRecogPos.SetCurSel(0);
    
	m_comboVehicleType.ResetContent();
	g_StringLanType(szText, "С","Small Plate");
	m_comboVehicleType.InsertString(0,szText);
	m_comboVehicleType.SetItemData(0,0);
	g_StringLanType(szText, "","Big Plate");
	m_comboVehicleType.InsertString(1,szText);
	m_comboVehicleType.SetItemData(1,1);
	m_comboVehicleType.SetCurSel(0);
    
	m_comboTimeType.ResetContent();
	g_StringLanType(szText, "","Daytime");
	m_comboTimeType.InsertString(0,szText);
	m_comboTimeType.SetItemData(0,0);
	g_StringLanType(szText, "","Night");
	m_comboTimeType.InsertString(1,szText);
	m_comboTimeType.SetItemData(1,1);
	m_comboTimeType.SetCurSel(0);
    
	m_comboSceneType.ResetContent();
	g_StringLanType(szText, "羯","Electrical Superintendent");
	m_comboSceneType.InsertString(0,szText);
	m_comboSceneType.SetItemData(0,0);
	g_StringLanType(szText, "","Gate");
	m_comboSceneType.InsertString(1,szText);
	m_comboSceneType.SetItemData(1,1);
	m_comboSceneType.SetCurSel(0);
    
	m_comboLocateType.ResetContent();
	g_StringLanType(szText, "֡λ","Frame Locate");
	m_comboLocateType.InsertString(0,szText);
	m_comboLocateType.SetItemData(0,0);
	g_StringLanType(szText, "λ","Field locate");
	m_comboLocateType.InsertString(1,szText);
	m_comboLocateType.SetItemData(1,1);
	m_comboLocateType.SetCurSel(0);
    
	m_comboRecogType.ResetContent();
	g_StringLanType(szText, "֡ʶ","Frame Recognition");
	m_comboRecogType.InsertString(0,szText);
	m_comboRecogType.SetItemData(0,0);
	g_StringLanType(szText, "ʶ","Field Recognition");
	m_comboRecogType.InsertString(1,szText);
	m_comboRecogType.SetItemData(1,1);
	m_comboRecogType.SetCurSel(0);

	for (int i = 0; i < MAX_ITC_LANE_NUM; i++)
	{
		CString strLaneNumber  = "";
		strLaneNumber.Format("%d",i + 1);
		m_comboLaneNumber.InsertString(i,strLaneNumber);
		m_comboLaneNumber.SetItemData(i,i);
	}
	m_comboLaneNumber.SetCurSel(0);
    
	m_comboLaneDirection.ResetContent();
	g_StringLanType(szText, "δ֪", "Unknown");
	m_comboLaneDirection.InsertString(0, szText);
	m_comboLaneDirection.SetItemData(0, ITC_LANE_DIRECTION_UNKNOW);

	g_StringLanType(szText, "ת", "Left");
	m_comboLaneDirection.InsertString(1, szText);
	m_comboLaneDirection.SetItemData(1, ITC_LANE_LEFT);
	
	g_StringLanType(szText, "ֱ", "Straight");
	m_comboLaneDirection.InsertString(2, szText);
	m_comboLaneDirection.SetItemData(2, ITC_LANE_STRAIGHT);
	
	g_StringLanType(szText, "ת+ֱ", "Left and Straight");
	m_comboLaneDirection.InsertString(3, szText);
	m_comboLaneDirection.SetItemData(3, ITC_LANE_LEFT_STRAIGHT);
	
	g_StringLanType(szText, "ת", "Right");
	m_comboLaneDirection.InsertString(4, szText);
	m_comboLaneDirection.SetItemData(4, ITC_LANE_RIGHT);
	
	g_StringLanType(szText, "ת+ת", "Left and Right");
	m_comboLaneDirection.InsertString(5, szText);
	m_comboLaneDirection.SetItemData(5, ITC_LANE_LEFT_RIGHT);
	
	g_StringLanType(szText, "ת+ֱ", "Right and Straight");
	m_comboLaneDirection.InsertString(6, szText);
	m_comboLaneDirection.SetItemData(6, ITC_LANE_RIGHT_STRAIGHT);
	
	g_StringLanType(szText, "ת+ת+ֱ", "Left and Right and Straight");
	m_comboLaneDirection.InsertString(7, szText);
	m_comboLaneDirection.SetItemData(7, ITC_LANE_LEFT_RIGHT_STRAIGHT);
	
	g_StringLanType(szText, "ת", "Left Wait");
	m_comboLaneDirection.InsertString(8, szText);
	m_comboLaneDirection.SetItemData(8, ITC_LANE_LEFT_WAIT);
	
	g_StringLanType(szText, "ֱд", "Straight Wait");
	m_comboLaneDirection.InsertString(9, szText);
	m_comboLaneDirection.SetItemData(9, ITC_LANE_STRAIGHT_WAIT);

	g_StringLanType(szText, "ʻ", "Forward");
	m_comboLaneDirection.InsertString(10, szText);
	m_comboLaneDirection.SetItemData(10, ITC_LANE_FORWARD);

	g_StringLanType(szText, "ʻ", "Backward");
	m_comboLaneDirection.InsertString(11, szText);
	m_comboLaneDirection.SetItemData(11, ITC_LANE_BACKWARD);

	g_StringLanType(szText, "˫ʻ", "Bothway");
	m_comboLaneDirection.InsertString(12, szText);
	m_comboLaneDirection.SetItemData(12, ITC_LANE_BOTHWAY);
	m_comboLaneDirection.SetCurSel(0);

	m_comboLaneUseageType.ResetContent();
	g_StringLanType(szText, "δ֪", "Unknown");
	m_comboLaneUseageType.InsertString(0, szText);
	m_comboLaneUseageType.SetItemData(0, ITC_LANE_USEAGE_UNKNOW);

	g_StringLanType(szText, "", "Ordinary lanes");
	m_comboLaneUseageType.InsertString(1, szText);
	m_comboLaneUseageType.SetItemData(1, ITC_LANE_CARRIAGEWAY);

	g_StringLanType(szText, "רõ", "Bus lanes");
	m_comboLaneUseageType.InsertString(2, szText);
	m_comboLaneUseageType.SetItemData(2, ITC_LANE_BUS);

	g_StringLanType(szText, "쳵", "Fast lane");
	m_comboLaneUseageType.InsertString(3, szText);
	m_comboLaneUseageType.SetItemData(3, ITC_LANE_FAST);

	g_StringLanType(szText, "", "Slow lane");
	m_comboLaneUseageType.InsertString(4, szText);
	m_comboLaneUseageType.SetItemData(4, ITC_LANE_SLOW);

	g_StringLanType(szText, "Ħг", "Motorcycle lane");
	m_comboLaneUseageType.InsertString(5, szText);
	m_comboLaneUseageType.SetItemData(5, ITC_LANE_MOTOR);

	g_StringLanType(szText, "ǻ", "Non-motor vehicle lane");
	m_comboLaneUseageType.InsertString(6, szText);
	m_comboLaneUseageType.SetItemData(6, ITC_LANE_NONMOTOR);

	g_StringLanType(szText, "򳵵", "Reversed lane");
	m_comboLaneUseageType.InsertString(7, szText);
	m_comboLaneUseageType.SetItemData(7, ITC_LANE_REVERSE_LANE);

	g_StringLanType(szText, "ֹ", "Ban trucks lane");
	m_comboLaneUseageType.InsertString(8, szText);
	m_comboLaneUseageType.SetItemData(8, ITC_LANE_BAN_TRUCKS);

	g_StringLanType(szText, "ϳ", "Mix lane");
	m_comboLaneUseageType.InsertString(9, szText);
	m_comboLaneUseageType.SetItemData(9, ITC_LANE_MIX);
	m_comboLaneUseageType.SetCurSel(0);

	m_comboDriveDirection.ResetContent();
    g_StringLanType(szText, "δ֪", "Unknown");
	m_comboDriveDirection.InsertString(0,szText);
	m_comboDriveDirection.SetItemData(0,ITC_LANE_DRIVE_UNKNOW);

	g_StringLanType(szText, "", "Up to down");
	m_comboDriveDirection.InsertString(1,szText);
	m_comboDriveDirection.SetItemData(1,ITC_LANE_DRIVE_UP_TO_DOWN);

	g_StringLanType(szText, "", "Down to up");
	m_comboDriveDirection.InsertString(2,szText);
	m_comboDriveDirection.SetItemData(2,ITC_LANE_DRIVE_DOWN_TO_UP);
	m_comboDriveDirection.SetCurSel(0);
}

void CDlgVcaITCTriggerCfg::DrawRgnFun(HDC hdc)
{   
    for (int i = 0; i < MAX_ITC_LANE_NUM; i++)
    {   
		DRAW_POLYGON_PARAM_EX struPolygonParam;
		memset(&struPolygonParam,0,sizeof(struPolygonParam));
		memcpy(&struPolygonParam.rcWnd, &m_rcPlayWnd, sizeof(m_rcPlayWnd));

		DRAW_LINE_PARAM  struLaneLineParam;
        if (i == m_nCurLaneIndex) 
        {
			struLaneLineParam.color = RGB(255,0,0);
			struPolygonParam.color = RGB(255,0,0);
			
        }
        else
        {  
			struLaneLineParam.color = RGB(0,255,0);
			struPolygonParam.color = RGB(85,170,255);
        }
        
		if (0 == m_iTriggerMode)
		{
			NET_ITC_LINE& struLaneLine = m_struItcTriggerCfg.struTriggerParam.uTriggerParam.struViaVtCoil.struLaneParam[i].struLaneLine;
			memcpy(&struLaneLineParam.rcWnd, &m_rcPlayWnd, sizeof(m_rcPlayWnd));
			struLaneLineParam.struVcaLine = struLaneLine.struLine;
		} 
		else if(1 == m_iTriggerMode)
		{
			NET_ITC_LINE& struLaneLine = m_struItcTriggerCfg.struTriggerParam.uTriggerParam.struPostMpr.struLaneParam[i].struLaneLine;
			memcpy(&struLaneLineParam.rcWnd, &m_rcPlayWnd, sizeof(m_rcPlayWnd));
			struLaneLineParam.struVcaLine = struLaneLine.struLine;
		}
        else if(2 == m_iTriggerMode)
        {
            NET_ITC_LINE& struLaneLine = m_struItcTriggerCfg.struTriggerParam.uTriggerParam.struIpcHvt.struLaneParam[i].struLaneLine;
            memcpy(&struLaneLineParam.rcWnd, &m_rcPlayWnd, sizeof(m_rcPlayWnd));
            struLaneLineParam.struVcaLine = struLaneLine.struLine;
		}

		CDrawFun::DrawLine(hdc, &struLaneLineParam);

		if (0 == m_iTriggerMode)
		{
			NET_ITC_POLYGON& struPlateRecog = m_struItcTriggerCfg.struTriggerParam.uTriggerParam.struViaVtCoil.struLaneParam[i].struPlateRecog;
			struPolygonParam.pArryPt = struPlateRecog.struPos;
			struPolygonParam.dwPtNum = struPlateRecog.dwPointNum;
		}
		else if(1 == m_iTriggerMode)
		{
			NET_ITC_POLYGON& struPlateRecog = m_struItcTriggerCfg.struTriggerParam.uTriggerParam.struPostMpr.struLaneParam[i].struPlateRecog;
			struPolygonParam.pArryPt = struPlateRecog.struPos;
			struPolygonParam.dwPtNum = struPlateRecog.dwPointNum;
		}
        else if(2 == m_iTriggerMode)
        {
            NET_ITC_POLYGON& struPlateRecog = m_struItcTriggerCfg.struTriggerParam.uTriggerParam.struIpcHvt.struLaneParam[i].struPlateRecog;
            struPolygonParam.pArryPt = struPlateRecog.struPos;
            struPolygonParam.dwPtNum = struPlateRecog.dwPointNum;
		}

		CDrawFun::DrawPolygonEx(hdc,&struPolygonParam);
	}
    
	DRAW_LINE_PARAM  struLaneBoundaryParam;
	
	if (0 == m_iTriggerMode)
	{
		NET_ITC_LINE&  struLaneBoundaryLine = m_struItcTriggerCfg.struTriggerParam.uTriggerParam.struViaVtCoil.struLaneBoundaryLine;
		struLaneBoundaryParam.color = RGB(255,255,0);
		memcpy(&struLaneBoundaryParam.rcWnd, &m_rcPlayWnd, sizeof(struLaneBoundaryParam.rcWnd));
		struLaneBoundaryParam.struVcaLine = struLaneBoundaryLine.struLine;
	}
	else if(1 == m_iTriggerMode)
	{
		NET_ITC_LINE&  struLaneBoundaryLine = m_struItcTriggerCfg.struTriggerParam.uTriggerParam.struPostMpr.struLaneBoundaryLine;
		struLaneBoundaryParam.color = RGB(255,255,0);
		memcpy(&struLaneBoundaryParam.rcWnd, &m_rcPlayWnd, sizeof(struLaneBoundaryParam.rcWnd));
		struLaneBoundaryParam.struVcaLine = struLaneBoundaryLine.struLine;
	}
    else if(2 == m_iTriggerMode)
    {
        NET_ITC_LINE&  struLaneBoundaryLine = m_struItcTriggerCfg.struTriggerParam.uTriggerParam.struIpcHvt.struLaneBoundaryLine;
        struLaneBoundaryParam.color = RGB(255,255,0);
        memcpy(&struLaneBoundaryParam.rcWnd, &m_rcPlayWnd, sizeof(struLaneBoundaryParam.rcWnd));
        struLaneBoundaryParam.struVcaLine = struLaneBoundaryLine.struLine;
	}

    CDrawFun::DrawLine(hdc, &struLaneBoundaryParam);
}

void CDlgVcaITCTriggerCfg::LoadViaLaneWndContent(int nLaneIndex)
{
	if (0 == m_iTriggerMode)
	{
		NET_DVR_VIA_LANE_PARAM& struViaLaneParam = m_struItcTriggerCfg.struTriggerParam.uTriggerParam.struViaVtCoil.struLaneParam[nLaneIndex];
		
		const NET_ITC_LANE_LOGIC_PARAM& struLaneLogicParam = struViaLaneParam.struLogicParam;
		
		m_nAssociateLaneNO = struViaLaneParam.byLaneNO;
		
		int i = 0;
		for (i = 0; i < m_comboLaneNumber.GetCount(); i++)
		{
			if (m_comboLaneNumber.GetItemData(i) == nLaneIndex)
			{
				m_comboLaneNumber.SetCurSel(i);
				break;
			}
		}
		
		for (i = 0; i < m_comboLaneUseageType.GetCount(); i++)
		{
			if (m_comboLaneUseageType.GetItemData(i) == struLaneLogicParam.byUseageType)
			{
				m_comboLaneUseageType.SetCurSel(i);
				break;
			}
		}
		
		for (i = 0; i < m_comboLaneDirection.GetCount(); i++)
		{
			if (m_comboLaneDirection.GetItemData(i) == struLaneLogicParam.byDirectionType)
			{
				m_comboLaneDirection.SetCurSel(i);
				break;
			}
		}
		
		for (i = 0; i < m_comboDriveDirection.GetCount(); i++)
		{
			if (m_comboDriveDirection.GetItemData(i) == struLaneLogicParam.byCarDriveDirect)
			{
				m_comboDriveDirection.SetCurSel(i);
				break;
			}
		}
	}
	else if (1 == m_iTriggerMode)
	{
		NET_ITC_LANE_MPR_PARAM& struMprLaneParam = m_struItcTriggerCfg.struTriggerParam.uTriggerParam.struPostMpr.struLaneParam[nLaneIndex];
		m_nAssociateLaneNO = struMprLaneParam.byLaneNO;
		if (1 == m_comSourceType.GetCurSel())
		{
			m_comIONo.SetCurSel(struMprLaneParam.uTssParamInfo.struIO.byIONo - 1);
			m_comTriggerType.SetCurSel(struMprLaneParam.uTssParamInfo.struIO.byTriggerType);
		}
		else if (2 == m_comSourceType.GetCurSel())
		{
			m_comRelateChan.SetCurSel(struMprLaneParam.uTssParamInfo.struRS485.byRelateChan);
		}
		//m_szSceneName.Format(_T("%s"), struMprLaneParam.szSceneName);
		int i = 0;
		for (i = 0; i < m_comboDriveDirection.GetCount(); i++)
		{
			if (m_comboDriveDirection.GetItemData(i) == struMprLaneParam.byCarDriveDirect)
			{
				m_comboDriveDirection.SetCurSel(i);
				break;
			}
		}
	}
    else if (2 == m_iTriggerMode)
    {
        NET_IPC_LANE_HVT_PARAM& struIpcHvtLaneParam = m_struItcTriggerCfg.struTriggerParam.uTriggerParam.struIpcHvt.struLaneParam[nLaneIndex];
        m_nAssociateLaneNO = struIpcHvtLaneParam.byLaneNO;
		int i = 0;
		for (i = 0; i < m_comboDriveDirection.GetCount(); i++)
		{
			if (m_comboDriveDirection.GetItemData(i) == struIpcHvtLaneParam.byCarDriveDirect)
			{
				m_comboDriveDirection.SetCurSel(i);
				break;
			}
		}
    }
}

void CDlgVcaITCTriggerCfg::SaveViaLaneWndContent(int nLaneIndex)
{
	if (0 == m_iTriggerMode)
	{
		NET_DVR_VIA_LANE_PARAM& struViaLaneParam = m_struItcTriggerCfg.struTriggerParam.uTriggerParam.struViaVtCoil.struLaneParam[nLaneIndex];
		struViaLaneParam.byLaneNO = m_nAssociateLaneNO;
		NET_ITC_LANE_LOGIC_PARAM& struLaneLogicParam = struViaLaneParam.struLogicParam;
		struLaneLogicParam.byUseageType = m_comboLaneUseageType.GetItemData(m_comboLaneUseageType.GetCurSel());
		struLaneLogicParam.byDirectionType = m_comboLaneDirection.GetItemData(m_comboLaneDirection.GetCurSel());
		struLaneLogicParam.byCarDriveDirect = m_comboDriveDirection.GetItemData(m_comboDriveDirection.GetCurSel());
	}
	else if(1 == m_iTriggerMode)
	{
		NET_ITC_LANE_MPR_PARAM& struMprLaneParam = m_struItcTriggerCfg.struTriggerParam.uTriggerParam.struPostMpr.struLaneParam[nLaneIndex];
		struMprLaneParam.byLaneNO = m_nAssociateLaneNO;
		if (1 == m_comSourceType.GetCurSel())
		{
			struMprLaneParam.uTssParamInfo.struIO.byIONo = m_comIONo.GetCurSel() + 1;
			struMprLaneParam.uTssParamInfo.struIO.byTriggerType = m_comTriggerType.GetCurSel();
		}
		else if (2 == m_comSourceType.GetCurSel())
		{
			struMprLaneParam.uTssParamInfo.struRS485.byRelateChan = m_comRelateChan.GetCurSel();
		}
		struMprLaneParam.byCarDriveDirect = m_comboDriveDirection.GetItemData(m_comboDriveDirection.GetCurSel());
	}
    else if(2 == m_iTriggerMode)
    {
        NET_IPC_LANE_HVT_PARAM& struIpcHvtLaneParam = m_struItcTriggerCfg.struTriggerParam.uTriggerParam.struIpcHvt.struLaneParam[nLaneIndex];
		struIpcHvtLaneParam.byLaneNO = m_nAssociateLaneNO;
		struIpcHvtLaneParam.byCarDriveDirect = m_comboDriveDirection.GetItemData(m_comboDriveDirection.GetCurSel());
    }
}

void CDlgVcaITCTriggerCfg::LoadWndContent()
{
	const NET_ITC_SINGLE_TRIGGERCFG&  struTriggerParam = m_struItcTriggerCfg.struTriggerParam;
	m_bTriggerCfg = struTriggerParam.byEnable;
	
 	if (0 == m_iTriggerMode)
	{
		const NET_DVR_VIA_VTCOIL_PARAM& struViaVtcoiParam = struTriggerParam.uTriggerParam.struViaVtCoil;
		m_bViaVtcoil = struViaVtcoiParam.byEnable;
		m_nLaneNum = struViaVtcoiParam.byLaneNum;

		const NET_ITC_PLATE_RECOG_PARAM& struPlateRecogParam = struViaVtcoiParam.struPlateRecog;
		m_strProvinceName = struPlateRecogParam.byDefaultCHN;
		m_bPlateRecog = struPlateRecogParam.byEnable;
		m_bVehicleLogoRecog = struPlateRecogParam.byVehicleLogoRecog;
		
		DWORD dwRecogMode = struPlateRecogParam.dwRecogMode;
		
		m_comboRecogPos.SetCurSel(dwRecogMode & 0x00000001 ? 1 : 0);
		m_comboVehicleType.SetCurSel(dwRecogMode & 0x00000002 ? 1 : 0);
		m_bVehicleColorRecog = (dwRecogMode & 0x00000004) ? TRUE : FALSE;
		m_bFarmVehicleRecog = (dwRecogMode & 0x00000008) ? TRUE : FALSE;
		m_bFuzzyRecog = (dwRecogMode & 0x00000010) ? TRUE : FALSE;
		m_comboLocateType.SetCurSel(dwRecogMode & 0x00000020 ? 1 : 0);
		m_comboRecogType.SetCurSel(dwRecogMode & 0x00000040 ? 1 : 0);
		m_comboTimeType.SetCurSel(dwRecogMode & 0x00000080 ? 1 : 0);
		m_bMotocarRecog = (dwRecogMode & 0x00000100) ? TRUE : FALSE;
		m_comboSceneType.SetCurSel(dwRecogMode & 0x00000200 ? 1 : 0);
		m_bMicroPlateRecog = (dwRecogMode & 0x00000400)? TRUE : FALSE;
		
		if (struPlateRecogParam.byProvince == 0xff)
		{
			m_comProvince.SetCurSel(35);
		} 
		else
		{
			m_comProvince.SetCurSel(struPlateRecogParam.byProvince);
		}

	    m_comRegion.SetCurSel(struPlateRecogParam.byRegion);
//		m_comboCarDriveDirect.SetCurSel(struPlateRecogParam.byCarDriveDirect);
	}
	else if (1 == m_iTriggerMode)
	{
		const NET_ITC_POST_MPR_PARAM& struMprParam = struTriggerParam.uTriggerParam.struPostMpr;
		m_nLaneNum = struMprParam.byLaneNum;
		m_comSourceType.SetCurSel(struMprParam.bySourceType);
		m_szSceneName.Format(_T("%s"), struMprParam.szSceneName);
		OnSelchangeComboSourceType();
		const NET_ITC_PLATE_RECOG_PARAM& struPlateRecogParam = struMprParam.struPlateRecog;
		m_strProvinceName = struPlateRecogParam.byDefaultCHN;
		m_bPlateRecog = struPlateRecogParam.byEnable;
		m_bVehicleLogoRecog = struPlateRecogParam.byVehicleLogoRecog;
		
		DWORD dwRecogMode = struPlateRecogParam.dwRecogMode;
		
		m_comboRecogPos.SetCurSel(dwRecogMode & 0x00000001 ? 1 : 0);
		m_comboVehicleType.SetCurSel(dwRecogMode & 0x00000002 ? 1 : 0);
		m_bVehicleColorRecog = (dwRecogMode & 0x00000004) ? TRUE : FALSE;
		m_bFarmVehicleRecog = (dwRecogMode & 0x00000008) ? TRUE : FALSE;
		m_bFuzzyRecog = (dwRecogMode & 0x00000010) ? TRUE : FALSE;
		m_comboLocateType.SetCurSel(dwRecogMode & 0x00000020 ? 1 : 0);
		m_comboRecogType.SetCurSel(dwRecogMode & 0x00000040 ? 1 : 0);
		m_comboTimeType.SetCurSel(dwRecogMode & 0x00000080 ? 1 : 0);
		m_bMotocarRecog = (dwRecogMode & 0x00000100) ? TRUE : FALSE;
		m_comboSceneType.SetCurSel(dwRecogMode & 0x00000200 ? 1 : 0);
		m_bMicroPlateRecog = (dwRecogMode & 0x00000400)? TRUE : FALSE;
		
		if (struPlateRecogParam.byProvince == 0xff)
		{
			m_comProvince.SetCurSel(35);
		} 
		else
		{
			m_comProvince.SetCurSel(struPlateRecogParam.byProvince);
		}


		m_comRegion.SetCurSel(struPlateRecogParam.byRegion);
//		m_comboCarDriveDirect.SetCurSel(struPlateRecogParam.byCarDriveDirect);
	}
    else if (2 == m_iTriggerMode)
    {
        const NET_IPC_POST_HVT_PARAM& struIpcHvtParam = struTriggerParam.uTriggerParam.struIpcHvt;
        m_bTriggerCfg = struIpcHvtParam.byEnable;
        m_nLaneNum = struIpcHvtParam.byLaneNum;
        m_szSceneName.Format(_T("%s"), struIpcHvtParam.szSceneName);
      
        const NET_ITC_PLATE_RECOG_PARAM& struPlateRecogParam = struIpcHvtParam.struPlateRecog;
        m_strProvinceName = struPlateRecogParam.byDefaultCHN;
        m_bPlateRecog = struPlateRecogParam.byEnable;
        m_bVehicleLogoRecog = struPlateRecogParam.byVehicleLogoRecog;
        
        DWORD dwRecogMode = struPlateRecogParam.dwRecogMode;
        
        m_comboRecogPos.SetCurSel(dwRecogMode & 0x00000001 ? 1 : 0);
        m_comboVehicleType.SetCurSel(dwRecogMode & 0x00000002 ? 1 : 0);
        m_bVehicleColorRecog = (dwRecogMode & 0x00000004) ? TRUE : FALSE;
        m_bFarmVehicleRecog = (dwRecogMode & 0x00000008) ? TRUE : FALSE;
        m_bFuzzyRecog = (dwRecogMode & 0x00000010) ? TRUE : FALSE;
        m_comboLocateType.SetCurSel(dwRecogMode & 0x00000020 ? 1 : 0);
        m_comboRecogType.SetCurSel(dwRecogMode & 0x00000040 ? 1 : 0);
        m_comboTimeType.SetCurSel(dwRecogMode & 0x00000080 ? 1 : 0);
        m_bMotocarRecog = (dwRecogMode & 0x00000100) ? TRUE : FALSE;
        m_comboSceneType.SetCurSel(dwRecogMode & 0x00000200 ? 1 : 0);
        m_bMicroPlateRecog = (dwRecogMode & 0x00000400)? TRUE : FALSE;
        
        if (struPlateRecogParam.byProvince == 0xff)
        {
            m_comProvince.SetCurSel(35);
        } 
        else
        {
            m_comProvince.SetCurSel(struPlateRecogParam.byProvince);
        }
		
		m_comRegion.SetCurSel(struPlateRecogParam.byRegion);
		
//		m_comboCarDriveDirect.SetCurSel(struPlateRecogParam.byCarDriveDirect);
	}
	

	LoadViaLaneWndContent(m_nCurLaneIndex);

	UpdateData(FALSE);
}

void CDlgVcaITCTriggerCfg::SaveWndContent()
{
	UpdateData(TRUE);
    
    m_struItcTriggerCfg.dwSize = sizeof(m_struItcTriggerCfg);

	
	NET_ITC_SINGLE_TRIGGERCFG&  struTriggerParam = m_struItcTriggerCfg.struTriggerParam;
	struTriggerParam.byEnable = m_bTriggerCfg;

	if (0 == m_iTriggerMode)
	{
		struTriggerParam.dwTriggerType = ITC_VIA_VIRTUALCOIL_TYPE;
		NET_DVR_VIA_VTCOIL_PARAM& struViaVtcoiParam = struTriggerParam.uTriggerParam.struViaVtCoil;
		
		struViaVtcoiParam.byEnable = m_bTriggerCfg/* m_bViaVtcoil*/;
		struViaVtcoiParam.byLaneNum = m_nLaneNum;
		
		NET_ITC_PLATE_RECOG_PARAM& struPlateRecogParam = struViaVtcoiParam.struPlateRecog;

		strncpy((char*)struPlateRecogParam.byDefaultCHN,m_strProvinceName,MAX_CHJC_NUM);
		struPlateRecogParam.byEnable = m_bTriggerCfg/*m_bPlateRecog*/;
		struPlateRecogParam.byVehicleLogoRecog = m_bVehicleLogoRecog;
		if (35 == m_comProvince.GetCurSel())
		{
			struPlateRecogParam.byProvince = 0xff;
		} 
		else
		{
			struPlateRecogParam.byProvince = m_comProvince.GetCurSel();
		}

		struPlateRecogParam.byRegion = m_comRegion.GetCurSel();
		
		
//		struPlateRecogParam.byCarDriveDirect = m_comboCarDriveDirect.GetCurSel();

		struPlateRecogParam.dwRecogMode = 0;
		struPlateRecogParam.dwRecogMode |= (m_comboRecogPos.GetItemData(m_comboRecogPos.GetCurSel())       == 0 ? 0x00000000 : 0x00000001);
		struPlateRecogParam.dwRecogMode |= (m_comboVehicleType.GetItemData(m_comboVehicleType.GetCurSel()) == 0 ? 0x00000000 : 0x00000002);
		struPlateRecogParam.dwRecogMode |= m_bVehicleColorRecog ? 0x00000004 : 0x00000000;
		struPlateRecogParam.dwRecogMode |= m_bFarmVehicleRecog  ? 0x00000008 : 0x00000000;
		struPlateRecogParam.dwRecogMode |= m_bFuzzyRecog        ? 0x00000010 : 0x00000000;
		struPlateRecogParam.dwRecogMode |= (m_comboLocateType.GetItemData(m_comboLocateType.GetCurSel())   == 0 ? 0x00000000 : 0x00000020);
		struPlateRecogParam.dwRecogMode |= (m_comboRecogType.GetItemData(m_comboRecogType.GetCurSel())     == 0 ? 0x00000000 : 0x00000040);
		struPlateRecogParam.dwRecogMode |= (m_comboTimeType.GetItemData(m_comboTimeType.GetCurSel())       == 0 ? 0x00000000 : 0x00000080);
		struPlateRecogParam.dwRecogMode |= m_bMotocarRecog      ? 0x00000100 : 0x00000000;
		struPlateRecogParam.dwRecogMode |= (m_comboSceneType.GetItemData(m_comboSceneType.GetCurSel())     == 0 ? 0x00000000 : 0x00000200);
		struPlateRecogParam.dwRecogMode |= m_bMicroPlateRecog   ? 0x00000400 : 0x00000000;
	}
	else if (1 == m_iTriggerMode)
	{
		struTriggerParam.dwTriggerType = ITC_POST_MPR_TYPE;
		NET_ITC_POST_MPR_PARAM& struMprParam = struTriggerParam.uTriggerParam.struPostMpr;
		struMprParam.byEnable = m_bTriggerCfg;
		struMprParam.byLaneNum = m_nLaneNum;
		struMprParam.bySourceType = m_comSourceType.GetCurSel();
		memcpy(struMprParam.szSceneName, m_szSceneName, m_szSceneName.GetLength());
		NET_ITC_PLATE_RECOG_PARAM& struPlateRecogParam = struMprParam.struPlateRecog;

		strncpy((char*)struPlateRecogParam.byDefaultCHN,m_strProvinceName,MAX_CHJC_NUM);
		struPlateRecogParam.byEnable = m_bTriggerCfg/*m_bPlateRecog*/;
		struPlateRecogParam.byVehicleLogoRecog = m_bVehicleLogoRecog;
		if (35 == m_comProvince.GetCurSel())
		{
			struPlateRecogParam.byProvince = 0xff;
		} 
		else
		{
			struPlateRecogParam.byProvince = m_comProvince.GetCurSel();
		}

		struPlateRecogParam.byRegion = m_comRegion.GetCurSel();
		
		
//		struPlateRecogParam.byCarDriveDirect = m_comboCarDriveDirect.GetCurSel();

		struPlateRecogParam.dwRecogMode = 0;
		struPlateRecogParam.dwRecogMode |= (m_comboRecogPos.GetItemData(m_comboRecogPos.GetCurSel())       == 0 ? 0x00000000 : 0x00000001);
		struPlateRecogParam.dwRecogMode |= (m_comboVehicleType.GetItemData(m_comboVehicleType.GetCurSel()) == 0 ? 0x00000000 : 0x00000002);
		struPlateRecogParam.dwRecogMode |= m_bVehicleColorRecog ? 0x00000004 : 0x00000000;
		struPlateRecogParam.dwRecogMode |= m_bFarmVehicleRecog  ? 0x00000008 : 0x00000000;
		struPlateRecogParam.dwRecogMode |= m_bFuzzyRecog        ? 0x00000010 : 0x00000000;
		struPlateRecogParam.dwRecogMode |= (m_comboLocateType.GetItemData(m_comboLocateType.GetCurSel())   == 0 ? 0x00000000 : 0x00000020);
		struPlateRecogParam.dwRecogMode |= (m_comboRecogType.GetItemData(m_comboRecogType.GetCurSel())     == 0 ? 0x00000000 : 0x00000040);
		struPlateRecogParam.dwRecogMode |= (m_comboTimeType.GetItemData(m_comboTimeType.GetCurSel())       == 0 ? 0x00000000 : 0x00000080);
		struPlateRecogParam.dwRecogMode |= m_bMotocarRecog      ? 0x00000100 : 0x00000000;
		struPlateRecogParam.dwRecogMode |= (m_comboSceneType.GetItemData(m_comboSceneType.GetCurSel())     == 0 ? 0x00000000 : 0x00000200);
		struPlateRecogParam.dwRecogMode |= m_bMicroPlateRecog   ? 0x00000400 : 0x00000000;
	}
    else if (2 == m_iTriggerMode)
    {
        struTriggerParam.dwTriggerType = IPC_POST_HVT_TYPE;
        NET_IPC_POST_HVT_PARAM& struIpcHvtParam = struTriggerParam.uTriggerParam.struIpcHvt;
        struIpcHvtParam.byEnable = m_bTriggerCfg;
        struIpcHvtParam.byLaneNum = m_nLaneNum;
        memcpy(struIpcHvtParam.szSceneName, m_szSceneName, m_szSceneName.GetLength());
        NET_ITC_PLATE_RECOG_PARAM& struPlateRecogParam = struIpcHvtParam.struPlateRecog;
        
        strncpy((char*)struPlateRecogParam.byDefaultCHN,m_strProvinceName,MAX_CHJC_NUM);
        struPlateRecogParam.byEnable = m_bTriggerCfg/*m_bPlateRecog*/;
        struPlateRecogParam.byVehicleLogoRecog = m_bVehicleLogoRecog;
        if (35 == m_comProvince.GetCurSel())
        {
            struPlateRecogParam.byProvince = 0xff;
        } 
        else
        {
            struPlateRecogParam.byProvince = m_comProvince.GetCurSel();
        }
 

		struPlateRecogParam.byRegion = m_comRegion.GetCurSel();
		
//		struPlateRecogParam.byCarDriveDirect = m_comboCarDriveDirect.GetCurSel();
		
        struPlateRecogParam.dwRecogMode = 0;
        struPlateRecogParam.dwRecogMode |= (m_comboRecogPos.GetItemData(m_comboRecogPos.GetCurSel())       == 0 ? 0x00000000 : 0x00000001);
        struPlateRecogParam.dwRecogMode |= (m_comboVehicleType.GetItemData(m_comboVehicleType.GetCurSel()) == 0 ? 0x00000000 : 0x00000002);
        struPlateRecogParam.dwRecogMode |= m_bVehicleColorRecog ? 0x00000004 : 0x00000000;
        struPlateRecogParam.dwRecogMode |= m_bFarmVehicleRecog  ? 0x00000008 : 0x00000000;
        struPlateRecogParam.dwRecogMode |= m_bFuzzyRecog        ? 0x00000010 : 0x00000000;
        struPlateRecogParam.dwRecogMode |= (m_comboLocateType.GetItemData(m_comboLocateType.GetCurSel())   == 0 ? 0x00000000 : 0x00000020);
        struPlateRecogParam.dwRecogMode |= (m_comboRecogType.GetItemData(m_comboRecogType.GetCurSel())     == 0 ? 0x00000000 : 0x00000040);
        struPlateRecogParam.dwRecogMode |= (m_comboTimeType.GetItemData(m_comboTimeType.GetCurSel())       == 0 ? 0x00000000 : 0x00000080);
        struPlateRecogParam.dwRecogMode |= m_bMotocarRecog      ? 0x00000100 : 0x00000000;
        struPlateRecogParam.dwRecogMode |= (m_comboSceneType.GetItemData(m_comboSceneType.GetCurSel())     == 0 ? 0x00000000 : 0x00000200);
        struPlateRecogParam.dwRecogMode |= m_bMicroPlateRecog   ? 0x00000400 : 0x00000000;
	}
	SaveViaLaneWndContent(m_nCurLaneIndex);
}

BOOL CDlgVcaITCTriggerCfg::GetITCTriggerCfg()
{
	NET_DVR_TRIGGER_COND struTriggerCond = {0};
    struTriggerCond.dwSize = sizeof(struTriggerCond);
	struTriggerCond.dwChannel = m_lChannel;
	if (0 == m_iTriggerMode)
	{
		struTriggerCond.dwTriggerMode = ITC_VIA_VIRTUALCOIL_TYPE;
	}
	else if (1 == m_iTriggerMode)
	{
		struTriggerCond.byDetSceneID = m_comDetSceneID.GetCurSel();
		struTriggerCond.dwTriggerMode = ITC_POST_MPR_TYPE;
	}
    else if (2 == m_iTriggerMode)
    {
        struTriggerCond.byDetSceneID = m_comDetSceneID.GetCurSel();
        struTriggerCond.dwTriggerMode = IPC_POST_HVT_TYPE;
	}
	
	
	DWORD dwStatus = 0;
	BOOL bRet = FALSE;
	
    if (!NET_DVR_GetDeviceConfig(m_lServerID, NET_DVR_GET_TRIGGEREX_CFG, 1,(LPVOID)&struTriggerCond, sizeof(struTriggerCond),
		&dwStatus,&m_struItcTriggerCfg, sizeof(m_struItcTriggerCfg)))
    {
        g_pMainDlg->AddLog(m_iDevIndex, OPERATION_FAIL_T, "NET_DVR_GET_TRIGGEREX_CFG Chan[%d]", m_lChannel);
        bRet = FALSE;
    }
    else
    {
        g_pMainDlg->AddLog(m_iDevIndex, OPERATION_SUCC_T, "NET_DVR_GET_TRIGGEREX_CFG Chan[%d]", m_lChannel);
        bRet = TRUE;
    }
	return bRet;
}

BOOL CDlgVcaITCTriggerCfg::SetITCTriggerCfg()
{
	NET_DVR_TRIGGER_COND struTriggerCond = {0};
	struTriggerCond.dwSize = sizeof(struTriggerCond);
	struTriggerCond.dwChannel = m_lChannel;
	struTriggerCond.dwTriggerMode = ITC_VIA_VIRTUALCOIL_TYPE;

	if (0 == m_iTriggerMode)
	{
		struTriggerCond.dwTriggerMode = ITC_VIA_VIRTUALCOIL_TYPE;
	}
	else if (1 == m_iTriggerMode)
	{
		struTriggerCond.byDetSceneID = m_comDetSceneID.GetCurSel();
		struTriggerCond.dwTriggerMode = ITC_POST_MPR_TYPE;
	}
    else if (2 == m_iTriggerMode)
    {
        struTriggerCond.byDetSceneID = m_comDetSceneID.GetCurSel();
        struTriggerCond.dwTriggerMode = IPC_POST_HVT_TYPE;
	}
	
    DWORD dwStatus = 0;
	BOOL bRet      = FALSE;
	
    if (!NET_DVR_SetDeviceConfig(m_lServerID, NET_DVR_SET_TRIGGEREX_CFG,1,(LPVOID)&struTriggerCond, sizeof(struTriggerCond),
		&dwStatus,&m_struItcTriggerCfg, sizeof(m_struItcTriggerCfg)))
    {
        g_pMainDlg->AddLog(m_iDevIndex, OPERATION_FAIL_T, "NET_DVR_SET_TRIGGEREX_CFG Chan[%d]", m_lChannel);
        bRet = FALSE;
    }
    else
    {
        g_pMainDlg->AddLog(m_iDevIndex, OPERATION_SUCC_T, "NET_DVR_SET_TRIGGEREX_CFG Chan[%d]", m_lChannel);
        bRet = TRUE;
    }
    return bRet;
}

void CDlgVcaITCTriggerCfg::OnSelchangeComboTriggerMode() 
{
	// TODO: Add your control notification handler code here
	m_iTriggerMode = m_comTriggerMode.GetCurSel();
	int i = m_comTriggerMode.GetCurSel();
	if (0 == i)
	{
		GetDlgItem(IDC_COMBO_DETSCENE_ID)->EnableWindow(FALSE); 
		GetDlgItem(IDC_EDIT_LANE_NUM)->EnableWindow(TRUE);  
		GetDlgItem(IDC_COMBO_SOURCE_TYPE)->EnableWindow(FALSE); 
		GetDlgItem(IDC_COMBO_LANE_NUMBER)->EnableWindow(TRUE); 
		GetDlgItem(IDC_EDIT_ASSOCIATE_LANENO)->EnableWindow(TRUE); 
		GetDlgItem(IDC_COMBO_LANE_USEAGETYPE)->EnableWindow(TRUE); 
		GetDlgItem(IDC_COMBO_LANE_DIRECTION)->EnableWindow(TRUE); 
		GetDlgItem(IDC_COMBO_DRIVE_DIRECTION)->EnableWindow(TRUE); 
		GetDlgItem(IDC_EDIT_SCENENAME)->EnableWindow(FALSE); 
		GetDlgItem(IDC_COMBO_IO_NO)->EnableWindow(FALSE); 
		GetDlgItem(IDC_COMBO_TRIGGER_TYPE)->EnableWindow(FALSE); 
		GetDlgItem(IDC_COMBO_RELATE_CHAN)->EnableWindow(FALSE); 
		GetDlgItem(IDC_COMBO_PROVINCE_TYPE)->EnableWindow(FALSE); 
	}
	else if (1 == i)
	{
		GetDlgItem(IDC_COMBO_DETSCENE_ID)->EnableWindow(TRUE); 
		GetDlgItem(IDC_EDIT_LANE_NUM)->EnableWindow(TRUE);  
		GetDlgItem(IDC_COMBO_SOURCE_TYPE)->EnableWindow(TRUE); 
		GetDlgItem(IDC_COMBO_LANE_NUMBER)->EnableWindow(TRUE); 
		GetDlgItem(IDC_EDIT_ASSOCIATE_LANENO)->EnableWindow(TRUE); 
		GetDlgItem(IDC_COMBO_LANE_USEAGETYPE)->EnableWindow(FALSE); 
		GetDlgItem(IDC_COMBO_LANE_DIRECTION)->EnableWindow(FALSE); 
		GetDlgItem(IDC_COMBO_DRIVE_DIRECTION)->EnableWindow(TRUE); 
		GetDlgItem(IDC_EDIT_SCENENAME)->EnableWindow(TRUE); 
		GetDlgItem(IDC_COMBO_IO_NO)->EnableWindow(TRUE); 
		GetDlgItem(IDC_COMBO_TRIGGER_TYPE)->EnableWindow(TRUE); 
		GetDlgItem(IDC_COMBO_RELATE_CHAN)->EnableWindow(TRUE); 
		GetDlgItem(IDC_COMBO_PROVINCE_TYPE)->EnableWindow(TRUE); 
	}
	else if (2 == i)
    {
        GetDlgItem(IDC_COMBO_DETSCENE_ID)->EnableWindow(TRUE); 
        GetDlgItem(IDC_EDIT_LANE_NUM)->EnableWindow(TRUE);  
        GetDlgItem(IDC_COMBO_SOURCE_TYPE)->EnableWindow(FALSE); 
        GetDlgItem(IDC_COMBO_LANE_NUMBER)->EnableWindow(TRUE); 
        GetDlgItem(IDC_EDIT_ASSOCIATE_LANENO)->EnableWindow(TRUE); 
        GetDlgItem(IDC_COMBO_LANE_USEAGETYPE)->EnableWindow(FALSE); 
        GetDlgItem(IDC_COMBO_LANE_DIRECTION)->EnableWindow(FALSE); 
        GetDlgItem(IDC_COMBO_DRIVE_DIRECTION)->EnableWindow(TRUE); 
        GetDlgItem(IDC_EDIT_SCENENAME)->EnableWindow(TRUE); 
        GetDlgItem(IDC_COMBO_IO_NO)->EnableWindow(FALSE); 
        GetDlgItem(IDC_COMBO_TRIGGER_TYPE)->EnableWindow(FALSE); 
        GetDlgItem(IDC_COMBO_RELATE_CHAN)->EnableWindow(FALSE); 
		GetDlgItem(IDC_COMBO_PROVINCE_TYPE)->EnableWindow(TRUE); 
    }
	OnSelchangeComboSourceType();

}

void CDlgVcaITCTriggerCfg::OnSelchangeComboSourceType() 
{
	// TODO: Add your control notification handler code here
	int i = m_comSourceType.GetCurSel();
	if (0 == i)
	{
		GetDlgItem(IDC_COMBO_IO_NO)->EnableWindow(FALSE);
		GetDlgItem(IDC_COMBO_TRIGGER_TYPE)->EnableWindow(FALSE); 
		GetDlgItem(IDC_COMBO_RELATE_CHAN)->EnableWindow(FALSE); 
	}
	else if (1 == i)
	{
		GetDlgItem(IDC_COMBO_IO_NO)->EnableWindow(TRUE);
		GetDlgItem(IDC_COMBO_TRIGGER_TYPE)->EnableWindow(TRUE); 
		GetDlgItem(IDC_COMBO_RELATE_CHAN)->EnableWindow(FALSE); 
	}
	else if (2 == i)
	{
		GetDlgItem(IDC_COMBO_IO_NO)->EnableWindow(FALSE);
		GetDlgItem(IDC_COMBO_TRIGGER_TYPE)->EnableWindow(FALSE); 
		GetDlgItem(IDC_COMBO_RELATE_CHAN)->EnableWindow(TRUE); 
	}
}

void CDlgVcaITCTriggerCfg::OnBtnGet() 
{
	// TODO: Add your control notification handler code here
	
	GetITCTriggerCfg();
	LoadWndContent();

}

void CDlgVcaITCTriggerCfg::OnBtnGetCurtriggermode() 
{
	// TODO: Add your control notification handler code here
    NET_DVR_CURTRIGGERMODE struTrigCfg = {0};
    DWORD dwReturn = 0;
    if (!NET_DVR_GetDVRConfig(m_lServerID, NET_DVR_GET_CURTRIGGERMODE, m_lChannel, &struTrigCfg, sizeof(struTrigCfg), &dwReturn))
     {
     	g_pMainDlg->AddLog(m_iDevIndex, OPERATION_FAIL_T, "NET_ITC_GET_TRIGGERCFG Chan[%d]", m_lChannel);
         return ;
     }
	else
    {
        g_pMainDlg->AddLog(m_iDevIndex, OPERATION_SUCC_T, "NET_ITC_GET_TRIGGERCFG Chan[%d]", m_lChannel);
    }
 
    if (struTrigCfg.dwTriggerType == ITC_POST_MPR_TYPE )
    {
    	m_comTriggerMode.SetCurSel(1);
    } 
    else if (struTrigCfg.dwTriggerType == IPC_POST_HVT_TYPE)
    {
         m_comTriggerMode.SetCurSel(2);
    }
     else if(struTrigCfg.dwTriggerType == ITC_VIA_VIRTUALCOIL_TYPE)
    {
     	m_comTriggerMode.SetCurSel(0);
    }

    OnSelchangeComboSourceType();
}

void CDlgVcaITCTriggerCfg::OnBtnSetCurtriggermode() 
{
	// TODO: Add your control notification handler code here
    NET_DVR_CURTRIGGERMODE struTrigCfg = {0};
    struTrigCfg.dwSize = sizeof(struTrigCfg);
    if (m_comTriggerMode.GetCurSel() == 0)
    {
        struTrigCfg.dwTriggerType = ITC_VIA_VIRTUALCOIL_TYPE;
    } 
    else if (m_comTriggerMode.GetCurSel() == 1)
    {
        struTrigCfg.dwTriggerType = ITC_POST_MPR_TYPE;
    }
    else if (m_comTriggerMode.GetCurSel() == 2)
    {
        struTrigCfg.dwTriggerType = IPC_POST_HVT_TYPE;
    }
    
    
    if (!NET_DVR_SetDVRConfig(m_lServerID, NET_DVR_SET_CURTRIGGERMODE, m_lChannel, &struTrigCfg, sizeof(struTrigCfg)))
    {
        g_pMainDlg->AddLog(m_iDevIndex, OPERATION_FAIL_T, "NET_DVR_SET_CURTRIGGERMODE Chan[%d]", m_lChannel);
        return ;
    }
	else
    {
        g_pMainDlg->AddLog(m_iDevIndex, OPERATION_SUCC_T, "NET_DVR_SET_CURTRIGGERMODE Chan[%d]", m_lChannel);
    }
}

void CDlgVcaITCTriggerCfg::OnBtnGetCalibration() 
{
	// TODO: Add your control notification handler code here
	NET_DVR_STD_CONFIG struCfg = {0};
    struCfg.lpCondBuffer = &m_lChannel;
    struCfg.dwCondSize = sizeof(m_lChannel);
    struCfg.lpOutBuffer = &m_struCalibration;
    struCfg.dwOutSize = sizeof(m_struCalibration);

    memset(m_szStatusBuf, 0, ISAPI_STATUS_LEN);
    struCfg.lpStatusBuffer = m_szStatusBuf;
    struCfg.dwStatusSize = ISAPI_STATUS_LEN;
    if(!NET_DVR_GetSTDConfig(m_lServerID, NET_DVR_GET_VEHICLE_CALIBRATION, &struCfg))
    {
        OutputDebugString(m_szStatusBuf);
        g_pMainDlg->AddLog(m_iDevIndex, OPERATION_FAIL_T, "NET_DVR_GET_VEHICLE_CALIBRATION");
    }
    else
    {
        g_pMainDlg->AddLog(m_iDevIndex, OPERATION_SUCC_T, "NET_DVR_GET_VEHICLE_CALIBRATION");
    }
}
